import 'package:geolocator/geolocator.dart';

import '2_Shared_Preference.dart';

ImpactGetGeolocation() async {
  bool serviceEnabled;
  LocationPermission permission;

  serviceEnabled = await Geolocator.isLocationServiceEnabled();
  if (!serviceEnabled) {
    return Future.error('Location services are disabled.');
  }

  permission = await Geolocator.checkPermission();
  if (permission == LocationPermission.denied) {
    permission = await Geolocator.requestPermission();
    if (permission == LocationPermission.denied) {
      return Future.error('Location permissions are denied');
    }
  }

  if (permission == LocationPermission.deniedForever) {
    return Future.error('Location permissions are permanently denied, we cannot request permissions.');
  }

  Geolocator.getCurrentPosition().then((value){
    var Lat = value.latitude;
    var Lng = value.longitude;
    ImpactUserLocation = "$Lat,$Lng";
    return ImpactUserLocation;
  });
  return "An Error Occured";
}


ImpactCheckGeoEnabled() async {
  LocationPermission? permission;

  if (permission == LocationPermission.deniedForever) {
    return false;
  }
  else if (permission == LocationPermission.always) {
    return true;
  }
  else if (permission == LocationPermission.denied) {
    return false;
  }
  else if (permission == LocationPermission.whileInUse) {
    return true;
  }

}





