import 'package:flutter/material.dart';
import 'package:impact/0_Impact_Global/2_Shared_Preference.dart';
import 'package:impact/2_Buttons/2_Impact_Button_2.dart';
import 'package:impact/4_TextFields/1_Ready_TF/1_Impact_Email_TF.dart';
import 'package:impact/4_TextFields/1_Ready_TF/2_Impact_Pass_TF.dart';
import 'package:impact/4_TextFields/2_TF_Decoration/1_Global_TF_Decoration.dart';

class ImpactFormSignIn1 extends StatefulWidget {
  Widget? BackDisplay;
  String? SignInTxt,ForgetPassTxt;
  TFDecoration? TFDecor;
  TextEditingController? EmailTFCtrl,PassTFCtrl;
  Function? SignInDo,ForgetPassDo,RegisterDo;
  Widget? Header;
  double? ElevationTop;
  TextStyle? ForgetPassStyle,RegisterStyle,HaveAccStyle;
  bool? ShowSocialLogin;
  Widget? FBWidget,GoogleWidget;
  Function? FBLoginDo,GoogleLoginDo;

  ImpactFormSignIn1({
    this.BackDisplay,
    this.SignInTxt,
    this.TFDecor,
    this.EmailTFCtrl,
    this.PassTFCtrl,
    this.SignInDo,
    this.ForgetPassDo,
    this.RegisterDo,
    this.Header,
    this.ElevationTop,
    this.ForgetPassStyle,
    this.RegisterStyle,
    this.HaveAccStyle,
    this.ShowSocialLogin,
    this.FBWidget,
    this.GoogleWidget,
    this.FBLoginDo,
    this.GoogleLoginDo,
  });

  @override
  State<StatefulWidget> createState() {
     return ImpactFormSignIn1State();
  }
}

class ImpactFormSignIn1State extends State<ImpactFormSignIn1> {
  GlobalKey<FormState> formKey = new GlobalKey<FormState>();

  @override
  Widget build(BuildContext context) {
    return Container(
      width :MediaQuery.of(context).size.width,
      height:MediaQuery.of(context).size.height,
      child:Stack(
        children: [

          (this.widget.BackDisplay==null)?SizedBox():this.widget.BackDisplay!,

          SingleChildScrollView(
            child:Center(
              child: Padding(
                padding: const EdgeInsets.only(
                    left:20,
                    right:20
                ),
                child: Form(
                  key:formKey,
                  child: Column(
                    mainAxisAlignment:MainAxisAlignment.center,
                    children: [

                      (this.widget.ElevationTop==null)?SizedBox(
                        height:MediaQuery.of(context).size.height*0.32
                      ):SizedBox(
                          height:this.widget.ElevationTop!
                      ),


                      (this.widget.Header!=null)?this.widget.Header!:SizedBox(),


                      ImpactEmailTF(
                        TFDecor:this.widget.TFDecor,
                        TFCtrl:(this.widget.EmailTFCtrl!=null)?this.widget.EmailTFCtrl:TextEditingController(),
                      ),
                      SizedBox(height:10,),

                      ImpactPassTF(
                        TFDecor:this.widget.TFDecor,
                        TFCtrl:(this.widget.PassTFCtrl!=null)?this.widget.PassTFCtrl:TextEditingController(),
                      ),
                      Align(
                        alignment:(ImpactSelectedLang!="Arabic")?Alignment.centerRight:Alignment.centerLeft,
                        child:TextButton(
                          child:Text(
                              (this.widget.ForgetPassTxt==null)?ImpactLang["ForgotPass"]:this.widget.ForgetPassTxt,
                              style:(this.widget.ForgetPassStyle==null)?TextStyle(
                                  color:ImpactPrimaryColor
                              ):this.widget.ForgetPassStyle,
                          ),
                          onPressed:(){
                             print("~~~~~~~~~~~~~Impact Forget Pass Clicked~~~~~~~~~~~~~~~~");
                             if(this.widget.ForgetPassDo!=null){
                               this.widget.ForgetPassDo!.call();
                             }
                          },
                        ),
                      ),

                      Padding(
                        padding: const EdgeInsets.all(8.0),
                        child: ImpactButton2(
                          Txt:(this.widget.SignInTxt==null)?ImpactLang["Login"]:this.widget.SignInTxt,
                          Do:(){
                            print("~~~~~~~~~~~~Impact SignIn Clicked~~~~~~~~~~~~~~~");
                            if(formKey.currentState!.validate()){
                              print("~~~~~~~~~~~~Impact SignIn Form Validated~~~~~~~~~~~~~~~");
                              this.widget.SignInDo!.call();
                            }
                            else {
                              print("~~~~~~~~~~~~Impact SignIn Form Not Validated~~~~~~~~~~~~~~~");
                            }
                          },
                          W:MediaQuery.of(context).size.width,
                          H:40.0,
                        ),
                      ),

                      SizedBox(
                        height:MediaQuery.of(context).size.width*0.091,
                      ),

                      (ImpactSelectedLang!="Arabic")?Row(
                        mainAxisAlignment:MainAxisAlignment.center,
                        children: [
                          Text(
                            ImpactLang["Dont_Have_Acc"],
                            style:(this.widget.HaveAccStyle==null)?TextStyle(
                              color:Colors.black
                            ):this.widget.HaveAccStyle,
                          ),
                          TextButton(
                            child:Text(
                                ImpactLang["Register"],
                                style:(this.widget.RegisterStyle==null)?TextStyle(
                                  color:ImpactPrimaryColor
                                ):this.widget.RegisterStyle,
                            ),
                            onPressed:(){
                              print("~~~~~~~Impact Register Clicked~~~~~~~~");
                              if(this.widget.RegisterDo!=null){
                                this.widget.RegisterDo!.call();
                              }
                            },
                          )
                        ],
                      ):Row(
                        mainAxisAlignment:MainAxisAlignment.center,
                        children: [

                          TextButton(
                            child:Text(
                                ImpactLang["Register"],
                              style:(this.widget.RegisterStyle==null)?TextStyle(
                                  color:ImpactPrimaryColor
                              ):this.widget.RegisterStyle,
                            ),
                            onPressed:(){
                              print("~~~~~~~Impact Register Clicked~~~~~~~~");
                              if(this.widget.RegisterDo!=null){
                                this.widget.RegisterDo!.call();
                              }
                            },
                          ),
                          Text(
                              ImpactLang["Dont_Have_Acc"],
                              style:(this.widget.HaveAccStyle==null)?TextStyle(
                                  color:Colors.black
                              ):this.widget.HaveAccStyle,
                          ),

                        ],
                      ),


                      SizedBox(
                        height:50,
                      ),

                      (this.widget.ShowSocialLogin==true)?Row(
                        mainAxisAlignment:MainAxisAlignment.center,
                        children: [
                          Container(
                            width:ImpactScreenWidth*0.23,
                            color:Colors.white,
                            height:1,
                          ),
                          SizedBox(width:5,),
                          Text(
                            "Continue With",
                            style:TextStyle(
                              color:Colors.white
                            ),
                          ),
                          SizedBox(width:5,),
                          Container(
                            width:ImpactScreenWidth*0.23,
                            color:Colors.white,
                            height:1,
                          ),
                        ],
                      ):SizedBox(),

                      (this.widget.ShowSocialLogin==true)?Padding(
                        padding: const EdgeInsets.all(28.0),
                        child: Row(
                          mainAxisAlignment:MainAxisAlignment.center,
                          children: [

                            GestureDetector(
                              onTap:(){
                                print("~~~~~~~FB Login Clicked~~~~~~~~~");
                                if(this.widget.FBLoginDo!=null){
                                  this.widget.FBLoginDo!.call();
                                }
                              },
                              child:(this.widget.FBWidget==null)?Image.network(
                                "https://lh3.googleusercontent.com/proxy/wgNVkQl_kUHNrbFTmSxBXo_I1kELUy-G_-Db0lpH6paCyVvoQHxIbBGQm0szg8mgMjWb07kzyEAAq3_J_zhbhnUE7vwLIOcnCXXPbkJRYdvb4Tjz0jF4nmwEWOYmAFEmysQRcWgVvolf6g",
                                width:50,
                                height:50,
                              ):SizedBox(),
                            ),

                            SizedBox(width:40,),

                            GestureDetector(
                              onTap:(){
                                print("~~~~~~~Google Login Clicked~~~~~~~~~");
                                if(this.widget.GoogleLoginDo!=null){
                                  this.widget.GoogleLoginDo!.call();
                                }
                              },
                              child:(this.widget.GoogleWidget==null)?Image.network(
                                "https://altitudemarketing.com/wp-content/uploads/2015/11/GoogleLogo.png",
                                width:50,
                                height:50,
                              ):SizedBox(),
                            ),




                          ],
                        ),
                      ):SizedBox(),


                      (this.widget.ShowSocialLogin==true)?SizedBox(
                        height:200,
                      ):SizedBox()


                    ],
                  ),
                ),
              ),
            ),
          ),


        ],
      )
    );
  }

}