import 'package:flutter/material.dart';
import 'package:impact/0_Impact_Global/2_Shared_Preference.dart';
import 'package:impact/2_Buttons/2_Impact_Button_2.dart';
import 'package:impact/4_TextFields/1_Ready_TF/1_Impact_Email_TF.dart';
import 'package:impact/4_TextFields/1_Ready_TF/2_Impact_Pass_TF.dart';
import 'package:impact/4_TextFields/1_Ready_TF/3_Impact_ConfirmPass_TF.dart';
import 'package:impact/4_TextFields/2_TF_Decoration/1_Global_TF_Decoration.dart';

class ImpactFormSignUp1 extends StatefulWidget {
  Widget? BackDisplay;
  String? SignUpTxt;
  TFDecoration? TFDecor;
  TextEditingController? EmailTFCtrl,PassTFCtrl,ConfirmPassTFCtrl;
  Function? SignUpDo,SignInDo;
  Widget? Header;

  ImpactFormSignUp1({
    this.BackDisplay,
    this.SignUpTxt,
    this.TFDecor,
    this.EmailTFCtrl,
    this.PassTFCtrl,
    this.ConfirmPassTFCtrl,
    this.SignInDo,
    this.SignUpDo,
    this.Header,
  });

  @override
  State<StatefulWidget> createState() {
    return ImpactFormSignUp1State();
  }
}

class ImpactFormSignUp1State extends State<ImpactFormSignUp1> {
  GlobalKey<FormState> formKey = new GlobalKey<FormState>();
  var ConfirmPass = "";
  var PassTxt     = " ";

  @override
  Widget build(BuildContext context) {
    return Container(
        width :MediaQuery.of(context).size.width,
        height:MediaQuery.of(context).size.height,
        child:Stack(
          children: [

            (this.widget.BackDisplay==null)?SizedBox():this.widget.BackDisplay!,

            SingleChildScrollView(
              child:Center(
                child: Padding(
                  padding: const EdgeInsets.only(
                      left:20,
                      right:20
                  ),
                  child: Form(
                    key:formKey,
                    child: Column(
                      mainAxisAlignment:MainAxisAlignment.center,
                      children: [

                        SizedBox(
                          height:(this.widget.Header!=null)?
                                    MediaQuery.of(context).size.height*0.32:
                                    MediaQuery.of(context).size.height*0.35,
                        ),

                        (this.widget.Header!=null)?this.widget.Header!:SizedBox(),

                        ImpactEmailTF(
                          TFDecor:this.widget.TFDecor,
                          TFCtrl:(this.widget.EmailTFCtrl!=null)?this.widget.EmailTFCtrl:TextEditingController(),
                        ),
                        SizedBox(height:10,),

                        ImpactPassTF(
                          TFDecor:this.widget.TFDecor,
                          TFCtrl:(this.widget.PassTFCtrl!=null)?this.widget.PassTFCtrl:TextEditingController(),
                          OnChangeDo:(value){
                            PassTxt=value;
                          },
                        ),
                        SizedBox(height:10,),


                        ImpactConfirmPassTF(
                          TFDecor:this.widget.TFDecor,
                          TFCtrl:(this.widget.ConfirmPassTFCtrl!=null)?this.widget.ConfirmPassTFCtrl:TextEditingController(),
                          CPassTxt:ConfirmPass,
                          PassTxt:PassTxt,
                          OnChangeDo:(value){
                            ConfirmPass = value;
                            print("~~~~~Pass $PassTxt");
                            print("~~~~CPass $ConfirmPass");
                          },
                        ),


                        Padding(
                          padding: const EdgeInsets.all(8.0),
                          child: ImpactButton2(
                            Txt:(this.widget.SignUpTxt==null)?ImpactLang["Register"]:this.widget.SignUpTxt,
                            Do:(){
                              print("~~~~~~~~~~~~Impact SignUp Clicked~~~~~~~~~~~~~~~");
                              if(formKey.currentState!.validate()){
                                print("~~~~~~~~~~~~Impact SignIn Form Validated~~~~~~~~~~~~~~~");
                                this.widget.SignInDo!.call();
                              }
                              else {
                                print("~~~~~~~~~~~~Impact SignUp Form Not Validated~~~~~~~~~~~~~~~");
                              }
                            },
                            W:MediaQuery.of(context).size.width,
                            H:40.0,
                          ),
                        ),

                        SizedBox(
                          height:MediaQuery.of(context).size.width*0.091,
                        ),

                        (ImpactSelectedLang=="English")?Row(
                          mainAxisAlignment:MainAxisAlignment.center,
                          children: [
                            Text(
                                ImpactLang["Have_Acc"]
                            ),
                            TextButton(
                              child:Text(
                                ImpactLang["Login"],
                                style:TextStyle(
                                    color:ImpactPrimaryColor
                                ),
                              ),
                              onPressed:(){
                                print("~~~~~~~Impact Already Have An Account Clicked~~~~~~~~");
                                if(this.widget.SignInDo!=null){
                                  this.widget.SignInDo!.call();
                                }
                              },
                            )
                          ],
                        ):Row(
                          mainAxisAlignment:MainAxisAlignment.center,
                          children: [

                            TextButton(
                              child:Text(
                                ImpactLang["Login"],
                                style:TextStyle(
                                    color:ImpactPrimaryColor
                                ),
                              ),
                              onPressed:(){
                                print("~~~~~~~Impact Already Have An Account Clicked~~~~~~~~");
                                if(this.widget.SignInDo!=null){
                                  this.widget.SignInDo!.call();
                                }
                              },
                            ),
                            Text(
                                ImpactLang["Have_Acc"]
                            ),

                          ],
                        )


                      ],
                    ),
                  ),
                ),
              ),
            ),


          ],
        )
    );
  }

}