import 'package:flutter/material.dart';
import 'package:impact/0_Impact_Global/2_Shared_Preference.dart';
import 'package:impact/11_Images/1_Single_Image.dart';
import 'package:impact/2_Buttons/2_Impact_Button_2.dart';
import 'package:impact/4_TextFields/1_Ready_TF/1_Impact_Email_TF.dart';
import 'package:impact/4_TextFields/1_Ready_TF/2_Impact_Pass_TF.dart';
import 'package:impact/4_TextFields/1_Ready_TF/6_Impact_Name_TF.dart';
import 'package:impact/4_TextFields/1_Ready_TF/7_Impact_Phone_TF.dart';
import 'package:impact/4_TextFields/2_TF_Decoration/1_Global_TF_Decoration.dart';

class ImpactEditProfile extends StatefulWidget {
  Widget? BackDisplay;
  String? UpdateBtnTxt;
  TFDecoration? TFDecor;
  TextEditingController? EmailTFCtrl,NameTFCtrl,PhoneTFCtrl;
  Function? SendEmailDo,ValidateDo;

  ImpactEditProfile({
    this.BackDisplay,
    this.UpdateBtnTxt,
    this.TFDecor,
    this.EmailTFCtrl,
    this.NameTFCtrl,
    this.PhoneTFCtrl,
    this.SendEmailDo,
    this.ValidateDo,
  });

  @override
  State<StatefulWidget> createState() {
    return ImpactEditProfileState();
  }
}

class ImpactEditProfileState extends State<ImpactEditProfile> {
  GlobalKey<FormState> formKey = new GlobalKey<FormState>();


  @override
  Widget build(BuildContext context) {
    return Container(
        width :MediaQuery.of(context).size.width,
        height:MediaQuery.of(context).size.height,
        child:Stack(
          children: [

            (this.widget.BackDisplay==null)?SizedBox():this.widget.BackDisplay!,

            SingleChildScrollView(
              child:Center(
                child: Padding(
                  padding: const EdgeInsets.only(
                      left:20,
                      right:20
                  ),
                  child: Form(
                    key:formKey,
                    child: Column(
                      mainAxisAlignment:MainAxisAlignment.center,
                      children: [


                        Center(child: ImpactSingleImage()),

                        SizedBox(height:35,),

                        ImpactNameTF(
                          TFDecor:this.widget.TFDecor,
                          TFCtrl:(this.widget.EmailTFCtrl!=null)?this.widget.EmailTFCtrl:TextEditingController(),
                        ),
                        SizedBox(height:10,),

                        ImpactEmailTF(
                          TFDecor:this.widget.TFDecor,
                          TFCtrl:(this.widget.EmailTFCtrl!=null)?this.widget.EmailTFCtrl:TextEditingController(),
                        ),
                        SizedBox(height:10,),

                        ImpactPhoneTF(
                          TFDecor:this.widget.TFDecor,
                          TFCtrl:(this.widget.PhoneTFCtrl!=null)?this.widget.PhoneTFCtrl:TextEditingController(),
                        ),
                        SizedBox(height:10,),

                        ImpactPassTF(
                          TFDecor:this.widget.TFDecor,
                          TFCtrl:TextEditingController(text:"1234"),
                          ShowEdit:true,
                          EditRedirection:ImpactEditProfile(),
                        ),
                        SizedBox(height:10,),



                        SizedBox(height:10,),


                        Padding(
                          padding: const EdgeInsets.all(8.0),
                          child: ImpactButton2(
                            Txt:(this.widget.UpdateBtnTxt==null)?ImpactLang["Send"]:this.widget.UpdateBtnTxt,
                            Do:(){
                              if(formKey.currentState!.validate()){

                              }
                            },
                            W:MediaQuery.of(context).size.width,
                            H:40.0,
                          ),
                        ),




                      ],
                    ),
                  ),
                ),
              ),
            ),


          ],
        )
    );
  }

}

