import 'package:cached_network_image/cached_network_image.dart';
import 'package:flutter/material.dart';
import 'package:impact/0_Impact_Global/2_Shared_Preference.dart';
import 'package:impact/8_Component/1_Clippy_Flutter/1_Arc.dart';


class TopBackgrounfImageClipper extends CustomClipper<Path> {
  @override
  getClip(Size size) {
    var path = Path();
    path.lineTo(0.0, size.height);
    var firstControlPoint = Offset(55, size.height / 1.4);
    var firstEndPoint = Offset(size.width / 1.7, size.height / 1.3);
    path.quadraticBezierTo(firstControlPoint.dx, firstControlPoint.dy,
        firstEndPoint.dx, firstEndPoint.dy);
    path.lineTo(size.width, size.height - 40);
    path.lineTo(size.width, 0.0);
    path.close();
    return path;
  }

  @override
  bool shouldReclip(CustomClipper oldClipper) {
    return false;
  }
}


class Impact_Form_1 extends StatefulWidget {

  @override
  State<StatefulWidget> createState() {
    return Impact_Form_1_State();
  }
}

class Impact_Form_1_State extends State<Impact_Form_1> {
  TextEditingController SearchTFCtrl = new TextEditingController();


  @override
  void initState(){
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      drawer: Drawer(),
      body: LayoutBuilder(
          builder: (context, constrainsts) {
            ImpactScreenWidth = MediaQuery.of(context).size.width;
            ImpactScreenHeight = MediaQuery.of(context).size.height;
            return Container(
                width:MediaQuery.of(context).size.width,
                height:MediaQuery.of(context).size.height,
                child:SingleChildScrollView(
                  child:Column(
                  children: [

                    Stack(
                      children: [

                        ClipPath(
                            clipper: TopBackgrounfImageClipper(),
                            child: Container(
                                width:MediaQuery.of(context).size.width,
                                height: 260,
                                child: Container(
                                    color:ImpactPrimaryColor,
                                    height:300,
                                    child:Align(
                                      alignment:Alignment.centerLeft,
                                      child:Container(
                                        width:MediaQuery.of(context).size.width*0.6,
                                        child:ListTile(
                                          leading:Hero(
                                            tag:"this.widget.SCB!.category_id",
                                            child:CachedNetworkImage(
                                              imageUrl:"https://events.flutter.dev/engage/assets/img/learn-hero.png",
                                              width:35,
                                              height:35,
                                              progressIndicatorBuilder: (context, url, downloadProgress) => CircularProgressIndicator(),
                                              errorWidget: (context, url, error) => Icon(Icons.error),
                                            ),
                                          ),
                                          title:Text(
                                            "this.widget.SCB!.desc_en"+" text text text tex tex tex tex tex tex tex",
                                            style:TextStyle(
                                                color:Colors.white,
                                                fontFamily:"GESS",
                                                fontSize:9
                                            ),
                                          ),
                                        ),

                                      ),
                                    )
                                )
                            )),

                        Padding(
                          padding: const EdgeInsets.only(left:25),
                          child: Arc(
                            edge: Edge.BOTTOM,
                            arcType: ArcType.CONVEY,
                            height: 20.0,
                            child: GestureDetector(
                              onTap: () => Navigator.pushNamed(context, '/arc_demo'),
                              child: Container(
                                color: Colors.blueGrey,
                                width: 60.0,
                                height: 85.0,
                                child: Center(
                                    child: Text(
                                      "this.widget.SCB!.name_en",
                                      style:TextStyle(
                                          color:Colors.white,
                                          fontFamily: "GESS",
                                          fontSize:8
                                      ),
                                    )
                                ),
                              ),
                            ),
                          ),
                        ),

                        Padding(
                          padding: const EdgeInsets.only(top:70),
                          child: Align(
                            alignment:Alignment.bottomRight,
                            child:CachedNetworkImage(
                              imageUrl:"https://events.flutter.dev/engage/assets/img/learn-hero.png",
                              width:165,
                              height:165,
                              fit:BoxFit.cover,
                              progressIndicatorBuilder: (context, url, downloadProgress) => CircularProgressIndicator(),
                              errorWidget: (context, url, error) => Icon(Icons.error),
                            ),
                          ),
                        ),

                        // Padding(
                        //   padding: const EdgeInsets.only(
                        //       top:240,
                        //       left:9,
                        //       right:9
                        //   ),
                        //   child: NormalTextField(
                        //     TextDirection: TxtDirection,
                        //     TC_Controller: SearchTFCtrl,
                        //     ErrorTxt: "error",
                        //     HintText: "Search",
                        //     Ic: Icon(
                        //       Icons.search,
                        //       color: Colors.white,
                        //     ),
                        //     IsEnabled: true,
                        //     CustomValidation: null,
                        //     Line: 1,
                        //     OnChangeDo: (value) {
                        //
                        //     },
                        //     BoxIcClr: (SelectedTheme == "Light")
                        //         ? Color(0xff63a4ff)
                        //         : Colors.black,
                        //   ),
                        // ),


                      ],
                    ),


                    for(int i=0;i<5;i++)
                      Stack(
                        children: [


                          Padding(
                            padding: const EdgeInsets.all(8.0),
                            child: Material(
                              borderRadius:BorderRadius.all(Radius.circular(10.0)),
                              elevation:3,
                              child:Container(
                                child:Padding(
                                    padding: const EdgeInsets.only(
                                        left:60
                                    ),
                                    child: ListTile(
                                      onTap:(){

                                      },
                                      title:Text(
                                        "CoursesLst[i].name_en",
                                        style:TextStyle(
                                            fontFamily:"GESS",
                                            color:ImpactPrimaryColor
                                        ),
                                      ),
                                      subtitle:Text(
                                       "CoursesLst[i].desc_en",
                                        style:TextStyle(
                                            fontFamily:"GESS",
                                            color:ImpactPrimaryColor
                                        ),
                                      ),
                                      trailing:Container(
                                        width:85.0,
                                        child: Row(
                                          children: [

                                            Icon(Icons.favorite,size:17,),
                                            Text(
                                                "100"
                                            ),
                                            SizedBox(width:2,),

                                            Icon(Icons.comment,size:17,),
                                            Text(
                                                "200"
                                            ),

                                          ],
                                        ),
                                      ),
                                    )
                                ),
                              ),
                            ),
                          ),

                          Padding(
                            padding: const EdgeInsets.all(8.0),
                            child: Container(
                                decoration: BoxDecoration(
                                  borderRadius: BorderRadius.circular(50),
                                  color: Colors.white,
                                  boxShadow: [
                                    BoxShadow(color:ImpactPrimaryColor, spreadRadius: 3),
                                  ],
                                ),
                                child:Padding(
                                  padding: const EdgeInsets.all(8.0),
                                  child: CachedNetworkImage(
                                    imageUrl:"https://events.flutter.dev/engage/assets/img/learn-hero.png",
                                    width:45,
                                    height:45,
                                    progressIndicatorBuilder: (context, url, downloadProgress) => CircularProgressIndicator(),
                                    errorWidget: (context, url, error) => Icon(Icons.error),
                                  ),
                                )
                            ),
                          ),


                        ],
                      )


                  ],
                ),

                ),
            );
          }
      ),
    );

  }

}