import 'dart:convert';
import 'package:file_picker/file_picker.dart';
import 'package:flutter/material.dart';
import 'package:impact/0_Impact_Global/2_Shared_Preference.dart';

late List<PlatformFile> ImpactMultipleImageFile            = [];
late List<Widget>       ImpactWidgetMultipleImageFileB64   = [];
late List<String>       ImpactMultipleImageFileB64         = [];


class ImpactMultipleImage extends StatefulWidget {
  @override
  State<StatefulWidget> createState() {
    return ImpactMultipleImageState();
  }
}

class ImpactMultipleImageState extends State<ImpactMultipleImage> {

  void FillImpactMultipleImageFileB64Options() {
    ImpactMultipleImageFile = [];
    ImpactMultipleImageFileB64 = [];

    ImpactWidgetMultipleImageFileB64 = [
      IconButton(
          onPressed: () {
            PickImage();
          },
          icon: Icon(Icons.add)
      )
    ];
  }

  Future<void> PickImage() async {
    await FilePicker.platform.pickFiles(
      allowMultiple:true,
      type: FileType.any,
      withData:true,
    ).then((files)  async {
      if(files != null && files.count>0){
        files.files.forEach((element) {
          ImpactMultipleImageFile.add(element);
          ImpactMultipleImageFileB64.add("data:image/png;base64,"+base64Encode(element.bytes!));
          ImpactWidgetMultipleImageFileB64.add(
              Image.memory(
                element.bytes!,
                width:150,
                height:150,
                fit:BoxFit.cover,
              )
          );
          setState(() {
          });
        });
      }
    });
    print("~~~~~~~~~~~~~ImpactSingleImageFile~~~~~~~~~~~");
    print(ImpactMultipleImageFile);
    print("~~~~~~~~~~~~~ImpactSingleImageFileB64~~~~~~~~~~~");
    print(ImpactMultipleImageFileB64);
    print("~~~~~~~~~~~~~ImpactWidgetMultipleImageFileB64~~~~~~~~~~~");
    print(ImpactWidgetMultipleImageFileB64);
  }



  @override
  void initState(){
    super.initState();
    FillImpactMultipleImageFileB64Options();
  }


  @override
  Widget build(BuildContext context) {
    return ClipRRect(
      child: Container(
          decoration:BoxDecoration(
            border:Border.all(
              color:ImpactPrimaryColor,
              width:1,
            ),
            borderRadius:BorderRadius.all(Radius.circular(8.0))
          ),
          width:ImpactScreenWidth,
          child:Wrap(
            alignment:WrapAlignment.center,
            runAlignment:WrapAlignment.start,
            children: [
              for(int i=0;i<ImpactWidgetMultipleImageFileB64.length;i++)
                Padding(
                  padding: const EdgeInsets.all(3.0),
                  child: Container(
                    width:100,
                    height:100,
                    child:ClipRRect(
                        borderRadius:BorderRadius.all(Radius.circular(5.0)),
                        child: ImpactWidgetMultipleImageFileB64[i]
                    ),
                  ),
                )
            ],
          )
      ),
    );
  }

}