import 'dart:convert';
import 'package:file_picker/file_picker.dart';
import 'package:flutter/material.dart';
import 'package:impact/0_Impact_Global/2_Shared_Preference.dart';

late PlatformFile ImpactCoverImageFile;
late String ImpactCoverImageFileB64;

class ImpactCoverImage extends StatefulWidget {
  double? W,H;

  ImpactCoverImage({
    this.W,
    this.H,
  });

  @override
  State<StatefulWidget> createState() {
    return ImpactCoverImageState();
  }
}

class ImpactCoverImageState extends State<ImpactCoverImage> {
  bool IsChanged = false;

  Future<void> PickImage() async {
    await FilePicker.platform.pickFiles(
      allowMultiple:false,
      type: FileType.image,
      withData:true,
    ).then((files)  async {
      if(files != null && files.count>0){
        files.files.forEach((element) {
          ImpactCoverImageFile     = element;
          ImpactCoverImageFileB64  = "data:image/png;base64,"+base64Encode(element.bytes!);
          setState(() {
            IsChanged=true;
          });
        });
      }
    });
    print("~~~~~~~~~~~~~ImpactCoverImageFile~~~~~~~~~~~");
    print(ImpactCoverImageFile);
    print("~~~~~~~~~~~~~ImpactCoverImageFileB64~~~~~~~~~~~");
    print(ImpactCoverImageFileB64);
  }

  @override
  Widget build(BuildContext context) {
    return Container(
        width:(this.widget.W==null)?ImpactScreenWidth:this.widget.W,
        height:(this.widget.W==null)?210:this.widget.W,
        child:Center(
          child: Stack(
            children: [


              Container(
                    width:(this.widget.W==null)?ImpactScreenWidth:this.widget.W,
                  height:(this.widget.W==null)?210:this.widget.W,

                  decoration:BoxDecoration(
                        // border:Border.all(
                        //   color:ImpactPrimaryColor,
                        //   width:1
                        // )
                      ),
                      child:(IsChanged==false)?Image.network(
                        ImpactUserProfilePic,
                        width:150,
                        height:150,
                        fit:BoxFit.cover,
                      ):Image.memory(
                        ImpactCoverImageFile.bytes!,
                        width:150,
                        height:150,
                        fit:BoxFit.cover,
                      )
                  ),


              Padding(
                padding: const EdgeInsets.all(4.0),
                child: Align(
                  alignment:Alignment.bottomRight,
                  child: ClipOval(
                      child:Container(
                        width:40,
                        height:40,
                        color:ImpactPrimaryColor,
                        child:IconButton(
                            icon:Icon(Icons.edit),
                            onPressed:(){
                              PickImage();
                            }
                        ),
                      )
                  ),
                ),
              )

            ],
          ),
        )
    );
  }

}