import 'dart:convert';
import 'package:cached_network_image/cached_network_image.dart';
import 'package:flutter/material.dart';
import 'package:impact/0_Impact_Global/2_Shared_Preference.dart';
import 'package:impact/8_Component/3_HTTP/Impact_HTTP.dart';

class ImpactTiles1 extends StatefulWidget {
  double? CW,CH;
  Color? FavClr;
  Function(Map data)? OnLikeDo;
  String? LoadMoreTxt,APIUrl;
  TextStyle? LoadMoreTextStyle;
  Widget? LoadingWidget;
  bool? FromAPI;
  List DataLst;
  int? EntryPerPage;
  Impact_HTTP_Methods?  HTTPMethod;
  Map<String,String>?   HTTPHeaders;
  Map<String,dynamic>?  HTTPBody;
  String? API_IC_Name,API_Title_Name,API_Desc_Name,ImageBaseurl,API_Page_Index_Name;
  int? ImpactTile1PageIndex = 1;
  Function(Map data)? EditDo;

  ImpactTiles1({
    this.CW                   ,
    this.CH                   ,
    this.FavClr               ,
    this.OnLikeDo             ,
    this.LoadMoreTxt          ,
    this.LoadMoreTextStyle    ,
    this.LoadingWidget        ,
    this.FromAPI              ,
    required this.DataLst     ,
    this.EntryPerPage         ,
    this.HTTPMethod           ,
    this.APIUrl               ,
    this.HTTPHeaders          ,
    this.HTTPBody             ,
    this.API_IC_Name          ,
    this.API_Title_Name       ,
    this.API_Desc_Name        ,
    this.ImageBaseurl         ,
    this.ImpactTile1PageIndex ,
    this.API_Page_Index_Name  ,
    this.EditDo               ,
  });


  @override
  State<StatefulWidget> createState() {
    return ImpactTiles1State();
  }


}

class ImpactTiles1State extends State<ImpactTiles1> {
  bool Loading     = true;
  bool HasMoreData = true;
  bool LoadingMore = false;
  int IncrementItems = 0;

  @override
  void initState(){
    super.initState();

    print("~~~~~~~~~~~~~List Length~~~~~~~~~~~~~");
    print(this.widget.DataLst.length);
    print("~~~~~~~~~~~~~List Length~~~~~~~~~~~~~");

    if(this.widget.EntryPerPage==null){
      this.widget.EntryPerPage = 5;
    }
    IncrementItems = this.widget.EntryPerPage!;
    if(this.widget.FromAPI==null || this.widget.FromAPI==false){
      setState(() {
        Loading = false;
      });
    }
    else {
      GetDataOnline("InitState");
    }
  }


  Future<Map> GetDataOnline(String CameFrom){
    Impact_HTTP(
      this.widget.APIUrl,
      this.widget.HTTPMethod,
      Headers:this.widget.HTTPHeaders,
      Body:this.widget.HTTPBody
    ).then((value){
      if(value["message"]=="success"){
        List data = jsonDecode(value["data"]);

        if(CameFrom=="LoadMore" && data.length==0){
          setState(() {
            HasMoreData = false;
          });
        }

        if(this.widget.ImpactTile1PageIndex==1){
          this.widget.DataLst = [];
        }
        for(int i=0; i<data.length ; i++ ){
          this.widget.DataLst.add(data[i]);
        }

        setState(() {
          Loading=false;
        });
      }
    });

    return Future.value({});
  }




  Future<void> LoadMoreOffline() async {
    await Future.delayed(Duration(seconds:1));
    if(this.widget.EntryPerPage==null){
      this.widget.EntryPerPage = 5;
    }

      if(this.widget.EntryPerPage==this.widget.DataLst.length){
        setState(() {
          HasMoreData = false;
        });
      }
      else {

        if(this.widget.EntryPerPage!+IncrementItems<this.widget.DataLst.length){
          setState(() {
            this.widget.EntryPerPage = this.widget.EntryPerPage!+IncrementItems;
          });
        }
        else {
          this.widget.EntryPerPage = this.widget.EntryPerPage!+(this.widget.DataLst.length-this.widget.EntryPerPage!);
          setState(() {
            HasMoreData=false;
          });
        }


      }




  }



  @override
  Widget build(BuildContext context) {
    return (Loading==false)?Container(
      width:(this.widget.CW==null)?ImpactScreenWidth:this.widget.CW,
      height:(this.widget.CH==null)?ImpactScreenHeight:this.widget.CH,
      child:SingleChildScrollView(
          child:Column(
            children: [

              for(int i=0;i<((this.widget.FromAPI==true)?this.widget.DataLst.length:(this.widget.EntryPerPage==null)?5:this.widget.EntryPerPage!);i++)
                Padding(
                  padding: const EdgeInsets.all(8.0),
                  child: Material(
                    elevation:4,
                    borderRadius:BorderRadius.all(Radius.circular(15.0)),
                    child:Container(
                        width:ImpactScreenWidth,
                        child:ListTile(
                          dense:true,
                          contentPadding:EdgeInsets.all(2.0),
                          leading:ClipOval(
                            child:Container(
                                decoration:BoxDecoration(
                                  color:Colors.white,
                                ),
                                width:60,
                                height:60,
                                child:CachedNetworkImage(
                                  imageUrl:this.widget.DataLst[i][this.widget.API_IC_Name.toString()],
                                )
                            ),
                          ),
                          title:Text(
                              this.widget.DataLst[i][this.widget.API_Title_Name.toString()]
                          ),
                          subtitle:Text(
                              this.widget.DataLst[i][this.widget.API_Desc_Name.toString()]
                          ),
                          trailing:Container(
                            width:100,
                            height:60,
                            child:Row(
                              children: [

                                IconButton(
                                  icon:Icon(
                                      Icons.edit,
                                      color:Colors.blueGrey
                                  ),
                                  onPressed:(this.widget.EditDo!=null)?(){
                                    print("~~~~~~~~~Edit Tapped~~~~~~~~~~~");
                                    this.widget.EditDo!.call(this.widget.DataLst[i]);
                                  }:(){
                                    print("~~~~~~~~~Edit Tapped~~~~~~~~~~~");
                                  },
                                ),

                                IconButton(
                                  icon:Icon(
                                    (1==1)?Icons.favorite:Icons.favorite_border,
                                    color:(this.widget.FavClr==null)?Colors.red:this.widget.FavClr,
                                  ),
                                  onPressed:(this.widget.OnLikeDo!=null)?(){
                                    print("~~~~~~~~~Favorite Tapped~~~~~~~~~~~");
                                    // setState(() {
                                    //   this.widget.DataLst![i].IsFav = !this.widget.DataLst![i].IsFav!;
                                    // });
                                    // this.widget.OnLikeDo!.call(this.widget.DataLst![i]);
                                  }:(){
                                    print("~~~~~~~~~Favorite Tapped~~~~~~~~~~~");
                                    // setState(() {
                                    //   this.widget.DataLst![i].IsFav = !this.widget.DataLst![i].IsFav!;
                                    // });
                                  },
                                ),


                              ],
                            ),
                          )
                        )
                    ),
                  ),
                ),

              (HasMoreData==true)?(LoadingMore==false)?TextButton(
                child:Text(
                  (this.widget.LoadMoreTxt==null)?"Load More":ImpactLang["Load More"],
                  style:(this.widget.LoadMoreTextStyle==null)?TextStyle():this.widget.LoadMoreTextStyle!,
                ),
                onPressed:() async {
                  setState(() {
                    this.widget.ImpactTile1PageIndex=this.widget.ImpactTile1PageIndex!+1;
                    LoadingMore = true;
                  });

                  if(this.widget.FromAPI==false || this.widget.FromAPI==null){
                    await LoadMoreOffline();
                  }
                  else {
                    this.widget.ImpactTile1PageIndex = this.widget.ImpactTile1PageIndex! + 1;
                    this.widget.HTTPBody![this.widget.API_Page_Index_Name.toString()] = this.widget.ImpactTile1PageIndex;
                    GetDataOnline("LoadMore");
                  }

                  setState(() {
                    LoadingMore = false;
                  });

                },
              ):(this.widget.LoadingWidget==null)?CircularProgressIndicator():this.widget.LoadingWidget!
                  :SizedBox(),


            ],
          )
      ),
    ):Center(
      child:(this.widget.LoadingWidget==null)?CircularProgressIndicator():this.widget.LoadingWidget!,
    );
  }

}