import 'dart:convert';
import 'package:cached_network_image/cached_network_image.dart';
import 'package:flutter/material.dart';
import 'package:impact/0_Impact_Global/2_Shared_Preference.dart';
import 'package:impact/8_Component/3_HTTP/Impact_HTTP.dart';

class ImpactTiles2 extends StatefulWidget {
  double? CW,CH,W,H,BorderRadius;
  List? DataLst;
  bool? FromAPI;
  Impact_HTTP_Methods?  HTTPMethod;
  Map<String,String>?   HTTPHeaders;
  Map<String,dynamic>?  HTTPBody;
  String? APIUrl,API_IC_Name,API_Title_Name,API_Desc_Name,ImageBaseurl,API_Page_Index_Name,API_ID_Name;
  int? ImpactTile1PageIndex = 1;
  Function(Map data)? Do;

  ImpactTiles2({
    this.DataLst   ,
    this.CW        ,
    this.CH        ,
    this.H         ,
    this.W           ,
    this.BorderRadius        ,
    this.FromAPI        ,
    this.APIUrl               ,
    this.HTTPHeaders          ,
    this.HTTPBody             ,
    this.API_IC_Name          ,
    this.API_Title_Name       ,
    this.API_Desc_Name        ,
    this.ImageBaseurl         ,
    this.ImpactTile1PageIndex ,
    this.API_Page_Index_Name  ,
    this.HTTPMethod  ,
    this.Do  ,
    this.API_ID_Name  ,
  });

  @override
  State<StatefulWidget> createState() {
    return ImpactTiles2State();
  }
}

class ImpactTiles2State extends State<ImpactTiles2> {
  bool Loading = true;
  bool HasMoreData = true;
  bool LoadingMore = false;
  int IncrementItems = 0;

  @override
  void initState(){
    super.initState();
    if(this.widget.FromAPI == true){
      setState(() {
        Loading = true;
      });
      GetDataOnline(
        "InitState"
      );
    }
    else {
      Loading = false;
    }
  }


  Future<Map> GetDataOnline(String CameFrom){
    Impact_HTTP(
        this.widget.APIUrl,
        this.widget.HTTPMethod,
        Headers:this.widget.HTTPHeaders,
        Body:this.widget.HTTPBody
    ).then((value){
      if(value["message"]=="success"){
        List data = jsonDecode(value["data"]);

        if(CameFrom=="LoadMore" && data.length==0){
          setState(() {
            HasMoreData = false;
          });
        }

        if(this.widget.ImpactTile1PageIndex==1){
          this.widget.DataLst = [];
        }
        for(int i=0; i<data.length ; i++ ){
          this.widget.DataLst!.add(data[i]);
        }

        setState(() {
          Loading=false;
        });
      }
    });

    return Future.value({});
  }



  @override
  Widget build(BuildContext context) {
    return Container(
      width:(this.widget.CW==null)?ImpactScreenWidth:this.widget.CW,
      height:(this.widget.CH==null)?200.0:this.widget.CH,
      child:(Loading==false)?ListView.builder(
        scrollDirection:Axis.horizontal,
          itemCount:this.widget.DataLst!.length,
          itemBuilder:(context,i){
            return  Padding(
              padding: const EdgeInsets.all(8.0),
              child: Material(
                elevation:4,
                borderRadius:BorderRadius.all(Radius.circular(
                    (this.widget.BorderRadius==null)?15.0:this.widget.BorderRadius!
                )),
                child:Container(
                    width:(this.widget.W==null)?240.0:this.widget.W,
                    height:(this.widget.H==null)?200.0:this.widget.H,
                    child:ListTile(
                      dense:true,
                      contentPadding:EdgeInsets.all(2.0),
                      onTap:(this.widget.Do==null)?(){
                        print("~~~~~~~~Impact Tiles Tapped~~~~~~~~");
                      }:(){
                        print("~~~~~~~~Impact Tiles Tapped~~~~~~~~");
                        this.widget.Do!.call(this.widget.DataLst![i]);
                      },
                      leading:ClipOval(
                        child:Container(
                            decoration:BoxDecoration(
                              color:Colors.white,
                            ),
                            width:60,
                            height:60,
                            child:CachedNetworkImage(
                              imageUrl:this.widget.DataLst![i][this.widget.API_ID_Name.toString()],
                            )
                        ),
                      ),
                      title:Text(
                        this.widget.DataLst![i][this.widget.API_Title_Name.toString()],
                      ),
                      subtitle:Text(
                        this.widget.DataLst![i][this.widget.API_Desc_Name.toString()],
                      ),
                    )
                ),
              ),
            );
          }
      ):Center(
        child:CircularProgressIndicator(),
      )
    );
  }

}