import 'package:flutter/material.dart';
import 'package:impact/0_Impact_Global/2_Shared_Preference.dart';

class ImpactButton5 extends StatelessWidget {
  var Txt,Do,W,H,GradClr,Clr,TxtColor,FontSize,FontFamily,Border_Radius;
  Widget? IC;
  Color? DefaultICColor,DefaultArrowColor;
  bool? IsGradient;

  ImpactButton5({
    required this.Txt,
    required this.Do,
    @required this.W,
    @required this.H,
    @required this.FontSize,
    @required this.FontFamily,
    @required this.TxtColor,
    @required this.GradClr,
    @required this.Border_Radius,
    @required this.IC,
    @required this.DefaultICColor,
    @required this.DefaultArrowColor,
    @required this.IsGradient,
    @required this.Clr,
  });

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
      onTap:this.Do,
      child:Container(
        width:(this.W==null)?200.0:this.W,
        height:(this.H==null)?65.0:this.H,
        child:Stack(
          children: [

            Container(
                width:this.W,
                height: this.H,
                margin: EdgeInsets.symmetric(vertical: 10),
                decoration: BoxDecoration(
                  gradient:(this.IsGradient==true)?LinearGradient(
                      colors:(this.GradClr==null)?[
                        Colors.blue,
                        Colors.blueGrey
                      ]:this.GradClr
                  ):LinearGradient(
                    colors:(this.Clr==null)?[
                      ImpactPrimaryColor,
                      ImpactPrimaryColor
                    ]:this.GradClr
                  ),
                  borderRadius: BorderRadius.circular(
                      (this.Border_Radius==null)?1.0:50.0
                  ),
                ),
                child:  Center(
                  child:Directionality(
                    textDirection: TextDirection.rtl,
                    child: Text(
                      this.Txt,
                      style: TextStyle(
                        color: Colors.white,
                        fontFamily: 'GESS',
                        fontSize: 12,
                        fontWeight: FontWeight.w700,
                      ),
                      textAlign: TextAlign.center,
                    ),
                  ),
                )
            ),

            (this.IC!=null)?this.IC!:Padding(
              padding: const EdgeInsets.all(8.0),
              child: Align(
                alignment:(ImpactSelectedLang!="Arabic")?Alignment.centerRight:Alignment.centerLeft,
                child: ClipOval(
                  child:Container(
                    width:25,
                    height:25,
                    color:(this.DefaultICColor==null)?ImpactPrimaryColor:this.DefaultICColor,
                    child:Center(
                      child:Icon(
                        (ImpactSelectedLang!="Arabic")?Icons.arrow_forward:Icons.arrow_back,
                        color:(this.DefaultArrowColor==null)?Colors.white:this.DefaultArrowColor,
                      ),
                    ),
                  ),
                ),
              ),
            ),


          ],
        ),
      )
    );
  }

}
