import 'package:flutter/material.dart';
import 'package:impact/4_TextFields/2_TF_Decoration/1_Global_TF_Decoration.dart';
import 'package:impact/4_TextFields/2_TF_Decoration/2_Impact_TFDecoration_1.dart';
import 'package:impact/4_TextFields/2_TF_Decoration/3_Impact_TFDecoration_2.dart';
import 'package:impact/4_TextFields/2_TF_Decoration/4_Impact_TFDecoration_3.dart';
import 'package:impact/8_Component/3_Email_Validator.dart';
import '../../0_Impact_Global/2_Shared_Preference.dart';


class ImpactEmailTF extends StatefulWidget {
  TextEditingController? TFCtrl;
  String? HintTextEmpty,HintTextWrong,HintText;
  TextDirection? TxtDirection;
  var OnChangeDo;
  bool? TFEnabled;
  TFDecoration? TFDecor;
  bool? ShowIcon;
  Widget? PrefixIcon;
  Color? BoxIcClr;


  ImpactEmailTF({
    this.TFCtrl,
    this.HintTextEmpty,
    this.HintTextWrong,
    this.TxtDirection,
    this.OnChangeDo,
    this.TFEnabled,
    this.HintText,
    this.TFDecor,
    this.ShowIcon,
    this.PrefixIcon,
    this.BoxIcClr,
  });

  @override
  State<StatefulWidget> createState() {
    return ImpactEmailTFState();
  }
}

class ImpactEmailTFState extends State<ImpactEmailTF> {







  @override
  Widget build(BuildContext context) {
    return Directionality(
      textDirection:(this.widget.TxtDirection!=null)?this.widget.TxtDirection!:ImpactTxtDirection,
      child:Stack(
        children: [


          Stack(
            children: [

              (this.widget.TFDecor == TFDecoration.Decoration_3)?Padding(
                padding: const EdgeInsets.only(
                    top:2.0
                ),
                child: Material(
                  elevation:(this.widget.TFDecor != TFDecoration.Decoration_3)?0.0:5.0,
                  borderRadius:BorderRadius.all(Radius.circular(40.0)),
                  child:Padding(
                    padding:EdgeInsets.only(
                      left:(this.widget.TFDecor != TFDecoration.Decoration_3)?0.0:50.0,
                    ),
                    child:Container(
                        child:Padding(
                          padding:EdgeInsets.only(
                              left:(this.widget.TFDecor == TFDecoration.Decoration_3)?18.0:0.0
                          ),
                          child:Container(
                            width:ImpactScreenWidth,
                            height:50,
                          ),

                        )
                    ),
                  ),
                ),
              ):SizedBox(),


              (this.widget.TFDecor==TFDecoration.Decoration_3)?Padding(
                padding: const EdgeInsets.only(
                    bottom:8.0
                ),
                child: Material(
                    borderRadius:BorderRadius.all(Radius.circular(50.0)),
                    elevation:30,
                    child:ClipOval(
                      child: Container(
                        width:55,
                        height:55,
                        child:(this.widget.PrefixIcon==null)?Icon(
                            Icons.alternate_email
                        ):this.widget.PrefixIcon,
                      ),
                    )
                ),
              ):SizedBox(),


            ],
          ),

          Padding(
            padding:EdgeInsets.only(
                left :(this.widget.TFDecor == TFDecoration.Decoration_3)?(ImpactSelectedLang!="Arabic")?59.0:0.0:0.0,
                right:(this.widget.TFDecor == TFDecoration.Decoration_3)?(ImpactSelectedLang=="Arabic")?59.0:0.0:0.0,
            ),
            child: TextFormField(
              controller:(this.widget.TFCtrl==null)?TextEditingController():this.widget.TFCtrl,
              textDirection:(this.widget.TxtDirection==null)?ImpactTxtDirection:this.widget.TxtDirection,
              onChanged:(this.widget.OnChangeDo!=null)?this.widget.OnChangeDo:(value){},
              enabled:(this.widget.TFEnabled!=null)?this.widget.TFEnabled:true,
              validator:(value){
                if(value!.isEmpty){
                  return (this.widget.HintTextEmpty!=null)?this.widget.HintTextEmpty:ImpactLang["Email_Empty_Descr"];
                }
                else if(!EmailValidator.validate(value)){
                  return (this.widget.HintTextWrong!=null)?this.widget.HintTextWrong:ImpactLang["Email_NValid_Descr"];
                }
              },
              decoration:(this.widget.TFDecor==null)?InputDecoration():

              (this.widget.TFDecor!.index==0)?ReturnTFDecoration1(
                  (this.widget.HintText!=null)?this.widget.HintText:ImpactLang["Email"],
                  this.widget.ShowIcon,
                  this.widget.PrefixIcon,
                  "Email"
              ):

              (this.widget.TFDecor!.index==1)?ReturnTFDecoration2(
                  (this.widget.HintText!=null)?this.widget.HintText:ImpactLang["Email"],
                  this.widget.ShowIcon,
                  this.widget.PrefixIcon,
                  "Email",
                  this.widget.BoxIcClr
              ):

              (this.widget.TFDecor!.index==2)?ReturnTFDecoration3(
                  (this.widget.HintText!=null)?this.widget.HintText:ImpactLang["Email"],
                  this.widget.ShowIcon,
                  this.widget.PrefixIcon,
                  "Email",
                  this.widget.BoxIcClr
              ):

              InputDecoration(),


            ),
          ),





        ],
      )
    );
  }

}