import 'package:flutter/material.dart';
import 'package:impact/0_Impact_Global/2_Shared_Preference.dart';
import 'package:impact/0_Impact_Global/7_Impact_Get_GeoLocation.dart';
import 'package:impact/4_TextFields/2_TF_Decoration/1_Global_TF_Decoration.dart';
import 'package:impact/4_TextFields/2_TF_Decoration/2_Impact_TFDecoration_1.dart';
import 'package:impact/4_TextFields/2_TF_Decoration/3_Impact_TFDecoration_2.dart';
import 'package:impact/8_Component/3_Email_Validator.dart';

class ImpactLocationTF extends StatefulWidget {
  TextEditingController? TFCtrl;
  String? HintTextEmpty,HintTextWrong,HintText;
  TextDirection? TxtDirection;
  var OnChangeDo;
  bool? TFEnabled;
  TFDecoration? TFDecor;
  bool? ShowIcon;
  Widget? PrefixIcon;
  Color? BoxIcClr;


  ImpactLocationTF({
    this.TFCtrl,
    this.HintTextEmpty,
    this.HintTextWrong,
    this.TxtDirection,
    this.OnChangeDo,
    this.TFEnabled,
    this.HintText,
    this.TFDecor,
    this.ShowIcon,
    this.PrefixIcon,
    this.BoxIcClr,
  });

  @override
  State<StatefulWidget> createState() {
    return ImpactLocationTFState();
  }
}

class ImpactLocationTFState extends State<ImpactLocationTF> {
  String LocationVal = "";

  @override
  void initState(){
    super.initState();
    LocationVal=ImpactGetGeolocation();
    this.widget.TFCtrl!.text=LocationVal;
  }



  @override
  Widget build(BuildContext context) {
    return GestureDetector(
      onTap:(){
        ImpactGetGeolocation();
      },
      child: Directionality(
        textDirection:(this.widget.TxtDirection!=null)?this.widget.TxtDirection!:ImpactTxtDirection,
        child: TextFormField(
          controller:(this.widget.TFCtrl==null)?TextEditingController():this.widget.TFCtrl,
          textDirection:(this.widget.TxtDirection==null)?ImpactTxtDirection:this.widget.TxtDirection,
          onChanged:(this.widget.OnChangeDo!=null)?this.widget.OnChangeDo:(value){},
          enabled:(this.widget.TFEnabled!=null)?this.widget.TFEnabled:true,
          validator:(value){
            if(value!.isEmpty){
              return (this.widget.HintTextEmpty!=null)?this.widget.HintTextEmpty:ImpactLang["Email_Empty_Descr"];
            }
            else if(!EmailValidator.validate(value)){
              return (this.widget.HintTextWrong!=null)?this.widget.HintTextWrong:ImpactLang["Email_NValid_Descr"];
            }
          },
          decoration:(this.widget.TFDecor==null)?InputDecoration():

          (this.widget.TFDecor!.index==0)?ReturnTFDecoration1(
              (this.widget.HintText!=null)?this.widget.HintText:ImpactLang["Email"],
              this.widget.ShowIcon,
              this.widget.PrefixIcon,
              "Location"
          ):


          (this.widget.TFDecor!.index==1)?ReturnTFDecoration2(
              (this.widget.HintText!=null)?this.widget.HintText:ImpactLang["Email"],
              this.widget.ShowIcon,
              this.widget.PrefixIcon,
              "Location",
              this.widget.BoxIcClr
          ):


          InputDecoration(),
        ),
      ),
    );
  }

}