import 'package:flutter/material.dart';
import 'package:impact/0_Impact_Global/2_Shared_Preference.dart';
import 'package:impact/4_TextFields/2_TF_Decoration/1_Global_TF_Decoration.dart';
import 'package:impact/4_TextFields/2_TF_Decoration/2_Impact_TFDecoration_1.dart';
import 'package:impact/4_TextFields/2_TF_Decoration/3_Impact_TFDecoration_2.dart';

class ImpactOldPassTF extends StatefulWidget {
  TextEditingController? TFCtrl;
  String? HintTextEmpty,HintTextWrong,HintText;
  TextDirection? TxtDirection;
  var OnChangeDo;
  bool? TFEnabled;
  TFDecoration? TFDecor;
  bool? ShowIcon,ShowEdit;
  Widget? PrefixIcon;
  Color? BoxIcClr;
  var EditRedirection;
  String? OldPassToValidate;

  ImpactOldPassTF({
    this.TFCtrl,
    this.HintTextEmpty,
    this.HintTextWrong,
    this.TxtDirection,
    this.OnChangeDo,
    this.TFEnabled,
    this.HintText,
    this.TFDecor,
    this.ShowIcon,
    this.PrefixIcon,
    this.BoxIcClr,
    this.ShowEdit,
    this.EditRedirection,
    this.OldPassToValidate
  });

  @override
  State<StatefulWidget> createState() {
    return ImpactOldPassTFState();
  }
}

class ImpactOldPassTFState extends State<ImpactOldPassTF> {

  bool ObscurePass = true;


  @override
  Widget build(BuildContext context) {
    return Directionality(
        textDirection:(this.widget.TxtDirection!=null)?this.widget.TxtDirection!:ImpactTxtDirection,
        child: Stack(
          children: [

            TextFormField(
              obscureText:ObscurePass,
              controller:(this.widget.TFCtrl==null)?TextEditingController():this.widget.TFCtrl,
              textDirection:(this.widget.TxtDirection==null)?ImpactTxtDirection:this.widget.TxtDirection,
              onChanged:(this.widget.OnChangeDo!=null)?this.widget.OnChangeDo:(value){},
              enabled:(this.widget.TFEnabled!=null)?this.widget.TFEnabled:true,
              validator:(value){
                if(value!.isEmpty){
                  return (this.widget.HintTextEmpty!=null)?this.widget.HintTextEmpty:ImpactLang["Old_Pass_Empty_Descr"];
                }
                else if(this.widget.OldPassToValidate!=this.widget.TFCtrl!.text){
                  return (this.widget.HintTextWrong!=null)?this.widget.HintTextWrong:ImpactLang["WOld_Pass_Empty_Title"];
                }
              },
              decoration:(this.widget.TFDecor==null)?InputDecoration():

              (this.widget.TFDecor!.index==0)?ReturnTFDecoration1(
                  (this.widget.HintText!=null)?this.widget.HintText:ImpactLang["Old_Pass"],
                  this.widget.ShowIcon,
                  this.widget.PrefixIcon,
                  "Password"
              ):


              (this.widget.TFDecor!.index==1)?ReturnTFDecoration2(
                  (this.widget.HintText!=null)?this.widget.HintText:ImpactLang["Old_Pass"],
                  this.widget.ShowIcon,
                  this.widget.PrefixIcon,
                  "Password",
                  this.widget.BoxIcClr
              ):


              InputDecoration(),
            ),

            Align(
              alignment:(ImpactSelectedLang=="English")?Alignment.centerRight:Alignment.centerLeft,
              child: IconButton(
                icon:(this.widget.ShowEdit==null)?Icon(
                    (ObscurePass==true)?Icons.remove_red_eye:Icons.remove_red_eye_outlined
                ):
                (this.widget.ShowEdit==true)?Icon(Icons.edit):SizedBox(),
                onPressed:(){
                  if(this.widget.ShowEdit==null){
                    setState((){
                      this.ObscurePass=!this.ObscurePass;
                    });
                  }
                  else if(this.widget.ShowEdit==true){
                    if(this.widget.EditRedirection!=null){
                      Navigator.of(context).push(MaterialPageRoute(builder:(context)=>this.widget.EditRedirection));
                    }
                  }

                },
              ),
            )


          ],
        )
    );
  }

}