import 'package:flutter/material.dart';
import 'package:impact/0_Impact_Global/2_Shared_Preference.dart';

InputDecoration ReturnTFDecoration2(HintText,ShowIcon,PrefixIcon,CameFrom,BoxIcClr){
  if(ShowIcon==null){
    ShowIcon=false;
  }
  if(PrefixIcon==null){
    if(CameFrom=="Email"){
      PrefixIcon = Icon(
          Icons.alternate_email,
          color:(ImpactSelectedTheme=="Dark")?Colors.white:Colors.black87,
      );
    }
    else if(CameFrom=="Password"){
      PrefixIcon = Icon(
          Icons.lock,
          color:(ImpactSelectedTheme=="Dark")?Colors.white:Colors.black87,
      );
    }
    else if(CameFrom=="Code"){
      PrefixIcon = Icon(
        Icons.assistant,
        color:(ImpactSelectedTheme=="Dark")?Colors.white:Colors.black87,
      );
    }
    else if(CameFrom=="Name"){
      PrefixIcon = Icon(
        Icons.person,
        color:(ImpactSelectedTheme=="Dark")?Colors.white:Colors.black87,
      );
    }
    else if(CameFrom=="Phone"){
      PrefixIcon = Icon(
        Icons.phone,
        color:(ImpactSelectedTheme=="Dark")?Colors.white:Colors.black87,
      );
    }
    else {
      PrefixIcon = Icon(
          Icons.alternate_email,
          color:(ImpactSelectedTheme=="Dark")?Colors.white:Colors.black87,
      );
    }
  }

  if(BoxIcClr==null){
    BoxIcClr = ImpactPrimaryColor;
  }

  return InputDecoration(
      contentPadding: EdgeInsets.symmetric(vertical:2,horizontal:10),
      border: new OutlineInputBorder(
          borderRadius: const BorderRadius.only(
            bottomLeft :Radius.circular(20.0),
            bottomRight:Radius.circular(20.0),
            topLeft    :Radius.circular(20.0),
            topRight   :Radius.circular(20.0),
          )
      ),
      filled: true,
      hintStyle: new TextStyle(
        color: Colors.grey[800],
      ),
      errorStyle:TextStyle(
        color:Colors.red,
      ),
      hintText: HintText,
      suffixIcon:SizedBox(),
      prefixIcon:Padding(
        padding: const EdgeInsets.only(right:0),
        child: Container(
          decoration:BoxDecoration(
              color:BoxIcClr,
              borderRadius: BorderRadius.only(
                bottomLeft :Radius.circular((ImpactSelectedLang=="English")?20.0:0.0),
                bottomRight:Radius.circular((ImpactSelectedLang=="Arabic")?20.0:0.0),
                topLeft    :Radius.circular((ImpactSelectedLang=="English")?20.0:0.0),
                topRight   :Radius.circular((ImpactSelectedLang=="Arabic")?20.0:0.0),
              )
          ),
          child:PrefixIcon,
        ),
      ),
      fillColor: Colors.white70
  );


}