import 'package:flutter/material.dart';
import 'package:impact/0_Impact_Global/2_Shared_Preference.dart';
import 'package:impact/0_Impact_Global/4_Set_Theme.dart';


class ImpactThemeSetting extends StatefulWidget {
  var parent;

  ImpactThemeSetting({
    required this.parent
  });

  @override
  State<StatefulWidget> createState() {
    return ImpactThemeSettingState();
  }
}

class ImpactThemeSettingState extends State<ImpactThemeSetting> {
  bool DarkMode = false;



  Future<void> _onSWChanged(bool value) async {
    setState(() {
      DarkMode = value;
    });

    if(DarkMode){
      ImpactSelectedTheme = "Dark";
    }
    else {
      ImpactSelectedTheme = "Light";
    }

    await ImpactSaveAndGetAllInfo();
    ImpactSetTheme();
    this.widget.parent?.setState(() {

    });
  }


  @override
  void initState(){
    super.initState();
    setState(() {
      if(ImpactSelectedTheme=="Dark"){
        DarkMode = true;
      }
      else {
        DarkMode = false;
      }
    });
  }



  @override
  Widget build(BuildContext context) {
    return Container(
      width: MediaQuery.of(context).size.width,
      child: Row(
        mainAxisAlignment: MainAxisAlignment.spaceBetween,
        children: [
          Row(
            children: [
              Icon(Icons.wb_sunny_outlined,
                  color: Colors.grey[900]),

              SizedBox(width: 5,),
              Text(" الوضع النهاري / الليلي",
                  style: TextStyle(
                    color: Colors.grey[700],
                    fontFamily: 'GESS',
                    fontSize: 12,
                  )
              ),

            ],
          ),

          Switch(
            activeColor:ImpactPrimaryColor,
            inactiveThumbColor:ImpactSecondaryColor,
            value: DarkMode,
            onChanged: _onSWChanged,
          ),

        ],
      ),
    );
  }

}