import 'package:flag/flag.dart';
import 'package:flutter/material.dart';
import 'package:impact/0_Impact_Global/2_Shared_Preference.dart';
import 'package:impact/8_Component/1_Menu_Button.dart';

class ImpactCountryItem {
  var Name,Code;

  ImpactCountryItem({
    required this.Name,
    required this.Code
  });

}


class ImpactCountrySetting extends StatefulWidget {
  var parent;
  List<ImpactCountryItem> CountryLst;

  ImpactCountrySetting({
    required this.parent,
    required this.CountryLst,
  });

  @override
  State<StatefulWidget> createState() {
    return ImpactCountrySettingState();
  }
}

class ImpactCountrySettingState extends State<ImpactCountrySetting> {
  late Widget ThemeChildBtn;
  String ThemeValue="";
  List<String> CountryNameLst = [];
  List<String> CountryCodeLst = [];
  var index=-1;

  @override
  void initState(){
    for(int i=0;i<this.widget.CountryLst.length;i++){
      CountryNameLst.add(this.widget.CountryLst[i].Name);
      CountryCodeLst.add(this.widget.CountryLst[i].Code);
    }
  }


  void SetBtn(){
    ThemeChildBtn =  Directionality(
      textDirection:TextDirection.rtl,
      child:Container(
        width: MediaQuery.of(context).size.width,
        height: 55,
        child: Padding(
          padding: const EdgeInsets.only(left: 16, right: 11),
          child: Row(
            mainAxisAlignment: MainAxisAlignment.end,
            children: <Widget>[
              (ImpactSelectedCountryCode!=null)?Container(
                width:35,
                height:35,
                child: Flag(
                  ImpactSelectedCountryCode
                ),
              ):Icon(Icons.language),
              SizedBox(width:10,),
              Expanded(
                child:Text(
                    (ImpactSelectedCountry==null || ImpactSelectedCountry=="")?"اختيار":ImpactSelectedCountry.toString(),
                    style:TextStyle(
                        color:ImpactPrimaryColor
                    ),
                    overflow: TextOverflow.ellipsis
                ),
              ),
              SizedBox(
                width: 22,
                height: 27,
                child: FittedBox(
                  fit: BoxFit.fill,
                  child: Icon(
                    Icons.arrow_drop_down,
                    color: ImpactPrimaryColor,
                  ),
                ),
              ),
            ],
          ),
        ),
      ),
    );
  }



  @override
  Widget build(BuildContext context) {
    SetBtn();
    return Directionality(
      textDirection:TextDirection.rtl,
      child: MenuButton<String>(
        child: ThemeChildBtn,
        items: CountryNameLst,
        selectedItem:ThemeValue,
        itemBuilder: (String value){
          if(value==CountryNameLst[0]){
            index=0;
          }
          index++;
          return Directionality(
            textDirection:TextDirection.rtl,
            child: Container(
                width:MediaQuery.of(context).size.width,
                height: 55,
                alignment: Alignment.centerRight,
                padding: const EdgeInsets.symmetric(vertical: 0.0, horizontal: 16),
                child: ListTile(
                  leading:Container(
                      width:35,
                      height:35,
                      child: Flag(CountryCodeLst[index-1])),
                  title:Text(
                    value,
                    textDirection:TextDirection.rtl,
                  ),

                )
            ),
          );
        },
        toggledChild: Container(
          child: ThemeChildBtn,
        ),

        onItemSelected: (String value) async {
          for(int i=0;i<this.widget.CountryLst.length;i++){
            if(this.widget.CountryLst[i].Name==value){
              ImpactSelectedCountryCode = CountryCodeLst[i];
              break;
            }
          }
          SetBtn();
          setState(() {
            ImpactSelectedCountry = value;
          });
          ImpactSaveAndGetAllInfo();
        },
        onMenuButtonToggle: (bool isToggle) {
          print(isToggle);
        },
      ),
    );
  }

}