import 'package:flutter/material.dart';
import 'package:impact/0_Impact_Global/2_Shared_Preference.dart';

class ImpactGuideContent extends StatelessWidget {
  var title,description;
  Color? BackgroundColor,TxtColor;

  ImpactGuideContent({
    required this.title,
    required this.description,
    this.BackgroundColor,
    this.TxtColor
  });

  @override
  Widget build(BuildContext context) {
    return Material(
      elevation:3,
      color:(this.BackgroundColor==null)?ImpactPrimaryColor:this.BackgroundColor,
      borderRadius:BorderRadius.all(Radius.circular(15.0)),
      child: Padding(
        padding: const EdgeInsets.all(4.0),
        child: Container(
          child: Padding(
            padding: const EdgeInsets.all(8.0),
            child: Column(
              mainAxisSize: MainAxisSize.min,
              crossAxisAlignment:(ImpactSelectedLang=="Arabic")?CrossAxisAlignment.end:CrossAxisAlignment.start,
              children: <Widget>[
                Text(
                  this.title.toString(),
                  textDirection:ImpactTxtDirection,
                  style: TextStyle(
                      fontWeight: FontWeight.bold,
                      color:(this.TxtColor==null)?Colors.white:this.TxtColor,
                      fontSize: 20.0
                  ),
                ),
                Padding(
                  padding: const EdgeInsets.only(top: 10.0),
                  child: Text(
                    this.description.toString(),
                    textDirection:ImpactTxtDirection,
                    style: TextStyle(
                      color:(this.TxtColor==null)?Colors.white:this.TxtColor,
                    ),
                  ),
                ),
              ],
            ),
          ),
        ),
      ),
    );
  }

}