import 'package:flutter/material.dart';
import 'package:impact/0_Impact_Global/2_Shared_Preference.dart';
import 'package:impact/12_Classes/1_Imapct_Grid_View_Data.dart';

class ImpactGridView  extends StatefulWidget {
  double? CW,CH,W,H,TxtFontSize,DescriptionFontSize,BorderRadius;
  Color? TxtColor,ContainerClr;
  Function(ImpactGridViewData data)? Do;
  bool? IsGradient;
  List<Color>? GradClr;
  TileMode? GradTileMode;
  List<ImpactGridViewData>? DataLst;

  ImpactGridView({
    this.CH,
    this.CW,
    this.W,
    this.H,
    this.DataLst,
    this.TxtColor,
    this.ContainerClr,
    this.TxtFontSize,
    this.DescriptionFontSize,
    this.BorderRadius,
    this.Do,
    this.IsGradient,
    this.GradClr,
    this.GradTileMode,
  });


  @override
  State<StatefulWidget> createState() {
    return ImpactGridViewState();
  }
}

class ImpactGridViewState extends State<ImpactGridView>  {

  @override
  void initState(){
    super.initState();
  }


  @override
  Widget build(BuildContext context) {
    return Container(
      width:(this.widget.CW==null)?ImpactScreenWidth:this.widget.CW,
      height:(this.widget.CH==null)?ImpactScreenHeight:this.widget.CH,
      child:SingleChildScrollView(
        child:Wrap(
          children: [

            SizedBox(
              width:ImpactScreenWidth,
              height:30,
            ),

            for(int i=0;i<((this.widget.DataLst==null)?0:this.widget.DataLst!.length);i++)
              GestureDetector(
                onTap:(this.widget.Do!=null)?(){
                  this.widget.Do!.call(this.widget.DataLst![i]);
                }:(){
                  print("~~~~~~~Impact Grid Button Tapped~~~~~~~~~");
                },
                child: Padding(
                  padding: const EdgeInsets.all(8.0),
                  child: Material(
                    elevation:5,
                    borderRadius:BorderRadius.all(Radius.circular(
                        (this.widget.BorderRadius==null)?1.0:this.widget.BorderRadius!
                    )),
                    child:Container(
                      width:(this.widget.W==null)?160.0:this.widget.W,
                      height:(this.widget.H==null)?160.0:this.widget.H,
                      decoration:BoxDecoration(
                        borderRadius:BorderRadius.all(Radius.circular(
                            (this.widget.BorderRadius==null)?1.0:this.widget.BorderRadius!
                        )),
                        gradient:(this.widget.IsGradient==true)?LinearGradient(
                            tileMode:(this.widget.GradTileMode==null)?TileMode.clamp:this.widget.GradTileMode!,
                            colors: (this.widget.GradClr==null)?[
                              Colors.blue,
                              Colors.blueGrey
                            ]:this.widget.GradClr!
                        ):LinearGradient(
                            tileMode:(this.widget.GradTileMode==null)?TileMode.clamp:this.widget.GradTileMode!,
                            colors:(this.widget.ContainerClr==null)?[
                              Colors.blue,
                              Colors.blue
                            ]:[
                              this.widget.ContainerClr!,
                              this.widget.ContainerClr!
                            ]
                        ),
                        color:(this.widget.ContainerClr==null)?ImpactPrimaryColor:this.widget.ContainerClr,

                      ),
                      child:Column(
                        mainAxisAlignment:MainAxisAlignment.center,
                        crossAxisAlignment:CrossAxisAlignment.center,
                        children: [

                          (this.widget.DataLst![i].IC==null)?Icon(
                            Icons.description,
                            color:Colors.white,
                            size:75,
                          ):this.widget.DataLst![i].IC!,

                          Text(
                              (this.widget.DataLst![i].Txt==null)?"Text $i":this.widget.DataLst![i].Txt.toString(),
                              textDirection:(ImpactSelectedLang=="Arabic")?TextDirection.rtl:TextDirection.ltr,
                              textAlign:TextAlign.center,
                              style:TextStyle(
                                color:(this.widget.TxtColor==null)?Colors.white:this.widget.TxtColor,
                                fontSize:(this.widget.TxtFontSize==null)?20:this.widget.TxtFontSize
                              ),
                          ),

                          Text(
                            (this.widget.DataLst![i].Desc==null)?"Description $i":this.widget.DataLst![i].Desc.toString(),
                            textDirection:(ImpactSelectedLang=="Arabic")?TextDirection.rtl:TextDirection.ltr,
                            textAlign:TextAlign.center,
                            style:TextStyle(
                                color:(this.widget.TxtColor==null)?Colors.white:this.widget.TxtColor,
                                fontSize:(this.widget.DescriptionFontSize==null)?14:this.widget.DescriptionFontSize
                            ),
                          ),

                        ],
                      ),
                    ),
                  ),
                ),
              ),

          ],
        ),
      ),
    );
  }

}