import 'package:flutter/material.dart';
import 'package:impact/0_Impact_Global/2_Shared_Preference.dart';

class ImpactPageSelectorData extends StatelessWidget {
  String Txt,Description,ImgPath;
  double? ImgWidth,ImgHeight;
  TextStyle? TxtStyle,DescriptionStyle;

  ImpactPageSelectorData({
    required this.Txt            ,
    required this.Description    ,
    required this.ImgPath        ,
    this.ImgHeight               ,
    this.ImgWidth                ,
    this.TxtStyle                ,
    this.DescriptionStyle        ,
  });

  Widget build(BuildContext context) {
    return Container(
      width:ImpactScreenWidth,
      height:ImpactScreenHeight,
      child:Column(
        mainAxisAlignment:MainAxisAlignment.center,
        crossAxisAlignment:CrossAxisAlignment.center,
        children: [

          Image.asset(
            this.ImgPath,
            width:(this.ImgWidth==null)?290:this.ImgWidth,
            height:(this.ImgHeight==null)?210:this.ImgHeight,
          ),

          Padding(
            padding: const EdgeInsets.only(
                left:28.0,
                right:28.0,
                bottom:10.0
            ),
            child: Text(
              this.Txt,
              textAlign:TextAlign.center,
              style:(this.TxtStyle==null)?TextStyle(
                  color:Colors.blue
              ):this.TxtStyle!,
            ),
          ),

          Padding(
            padding: const EdgeInsets.only(
                left:28.0,
                right:28.0,
                bottom:128.0
            ),
            child: Text(
              this.Description,
              textAlign:TextAlign.center,
              style:(this.DescriptionStyle==null)?TextStyle(
                  color:Colors.blue
              ):this.DescriptionStyle!,
            ),
          ),

        ],
      ),

    );
  }

}

