import 'package:flutter/material.dart';
import 'package:impact/0_Impact_Global/2_Shared_Preference.dart';
import 'package:impact/8_Component/2_Waves/1_PS2_1.dart';
import 'package:impact/8_Component/2_Waves/2_PS2_2.dart';
import 'package:impact/8_Component/2_Waves/3_PS2_3.dart';
import 'package:impact/8_Component/2_Waves/4_PS2_4.dart';


class ImpactPageSelector2Data extends StatelessWidget {
  String Txt,Description,ImgPath;
  double? ImgWidth,ImgHeight;
  TextStyle? TxtStyle,DescriptionStyle;

  ImpactPageSelector2Data({
    required this.Txt            ,
    required this.Description    ,
    required this.ImgPath        ,
    this.ImgHeight               ,
    this.ImgWidth                ,
    this.TxtStyle                ,
    this.DescriptionStyle        ,
  });

  Widget build(BuildContext context) {
    return Container(
      width:ImpactScreenWidth,
      height:ImpactScreenHeight,
      child:Stack(
        children: [

          Align(
            alignment:Alignment.topLeft,
            child:ClipPath(
              clipper: PS2_3(),
              child: Container(
                width:120,
                height:300,
                decoration:BoxDecoration(
                    gradient:LinearGradient(
                        colors:[
                          Color(0xff28a4dc),
                          Color(0xff2797d2).withOpacity(0.9),
                          Color(0xff2794cf),
                          Color(0xff268ac7)
                        ],
                        begin:Alignment.topCenter
                    )
                ),
              ),
            ),
          ),



          Align(
            alignment:Alignment.topRight,
            child:ClipPath(
              clipper: PS2_4(),
              child: Container(
                width:120,
                height:270,
                decoration:BoxDecoration(
                    gradient:LinearGradient(
                        colors:[
                          Color(0xff28a4dc),
                          Color(0xff2797d2).withOpacity(0.9),
                          Color(0xff2794cf),
                          Color(0xff268ac7)
                        ]
                    )
                ),
              ),
            ),
          ),




          Align(
            alignment:Alignment.bottomCenter,
            child:Stack(
              children: [

                Align(
                  alignment:Alignment.bottomCenter,
                  child:ClipPath(
                    clipper: PS2_1(),
                    child: Container(
                      width:ImpactScreenWidth,
                      height:265,
                      decoration:BoxDecoration(
                          gradient:LinearGradient(
                              colors:[
                                Color(0xffdaeaf2),
                                Color(0xffcce4f4),
                                Color(0xffd4e4f4)
                              ]
                          )
                      ),
                    ),
                  ),
                ),

                Align(
                  alignment:Alignment.bottomCenter,
                  child:ClipPath(
                    clipper: PS2_2(),
                    child: Container(
                      width:ImpactScreenWidth,
                      height:200,
                      decoration:BoxDecoration(
                          gradient:LinearGradient(
                              colors:[
                                Color(0xffc1d6f4).withOpacity(0.5),
                                Color(0xffbcd4f4),
                              ]
                          )
                      ),
                    ),
                  ),
                ),


              ],
            )
          ),

          Container(
            width:ImpactScreenWidth,
            height:ImpactScreenHeight,
            child: Column(
              mainAxisAlignment:MainAxisAlignment.center,
              crossAxisAlignment:CrossAxisAlignment.center,
              children: [

                Image.asset(
                    this.ImgPath,
                    width:(this.ImgWidth==null)?290:this.ImgWidth,
                    height:(this.ImgHeight==null)?210:this.ImgHeight,
                  ),


                Padding(
                  padding: const EdgeInsets.only(
                      bottom:13.0
                  ),
                  child: Text(
                    this.Txt,
                    textAlign:TextAlign.center,
                    style:(this.TxtStyle==null)?TextStyle(
                        color:Colors.blue
                    ):this.TxtStyle,
                  ),
                ),

                Padding(
                  padding: const EdgeInsets.only(
                      bottom:100.0
                  ),
                  child: Text(
                    this.Txt,
                    textAlign:TextAlign.center,
                    style:(this.DescriptionStyle==null)?TextStyle(
                        color:Colors.blue
                    ):this.DescriptionStyle,
                  ),
                ),



              ],
            ),
          ),

        ],
      ),
    );
  }

}

