import 'package:flutter/material.dart';
import 'package:impact/0_Impact_Global/2_Shared_Preference.dart';
import 'package:impact/2_Buttons/2_Impact_Button_2.dart';
import '../Impact_Page_Selector_Guide.dart';
import 'Class/ImpactPageSelector2Data.dart';
import 'Widgets/PS2_Button_NotNow.dart';
import 'Widgets/PS2_Next_Button_LTR.dart';
import 'Widgets/PS2_Next_Button_RTL.dart';


class Impact_PageSelector_2 extends StatefulWidget {
  List<ImpactPageSelector2Data>? PagesContent;
  var RedirectTo;
  Color? ActiveTabPageSelectorColor,GuideBgColor;
  Color? TabPageSelectorColor;
  bool? IsRTL,ShowTutorial;
  String? NextTxt,NotNowTxt,NextGuideTxt,NotNowGuideTxt,SkipTxt,CloseTxt;
  Alignment? SkipAlignment;
  Widget? NotNowWidget,NextWidget,CloseWidget;
  Color? TargetBgColor;

  Impact_PageSelector_2({
    required this.PagesContent,
    required this.RedirectTo,
    required this.ActiveTabPageSelectorColor,
    required this.TabPageSelectorColor,
    this.IsRTL,
    this.ShowTutorial,
    this.NextTxt,
    this.NotNowTxt,
    this.NextGuideTxt,
    this.NotNowGuideTxt,
    this.SkipTxt,
    this.SkipAlignment,
    this.GuideBgColor,
    this.CloseTxt,
    this.NotNowWidget,
    this.NextWidget,
    this.CloseWidget,
    this.TargetBgColor,
  });

  @override
  State<StatefulWidget> createState() {
    return Impact_PageSelector_2_State();
  }
}


class Impact_PageSelector_2_State extends State<Impact_PageSelector_2> with SingleTickerProviderStateMixin {
  TabController? PageSelectorTabController;

  @override
  void initState(){
    super.initState();
    if(ImpactSelectedLang=="Arabic"){
      this.widget.IsRTL = true;
    }
    PageSelectorTabController = new TabController(
        length: this.widget.PagesContent!.length,
        vsync: this,
        initialIndex:(this.widget.IsRTL==true)?this.widget.PagesContent!.length-1:0
    );
    PageSelectorTabController?.addListener(() {
      setState(() {

      });
    });
    if(this.widget.ShowTutorial==true){
      initImpactPageSelectorTargets(
          NextTitle      : this.widget.NextTxt,
          NextGuideTxt   : this.widget.NextGuideTxt,
          NotNowTitle    : this.widget.NotNowTxt,
          NotNowGuideTxt : this.widget.NotNowGuideTxt,
          TargetBgColor  : this.widget.TargetBgColor,
          CameFrom       : "PS2",
          PrevGuideTxt   : "",
          PrevTitle:""
      );
      showImpactPageSelectorTutorial(
          context,
          this.widget.GuideBgColor,
          this.widget.SkipTxt,
          this.widget.SkipAlignment,
          "PS2",
          this,
          this.widget.IsRTL
      );
    }
  }

  void NextLTRFunction(){
    print("Clicked!!!");
    var index = PageSelectorTabController!.index;
    TabController controller = PageSelectorTabController!;
    setState(() {
      if (!controller.indexIsChanging && controller.index!=controller.length ) {
        controller.animateTo(controller.index + 1);
      }
    });
  }

  void NextRTLFunction(){
    print("Clicked!!!");
    TabController controller = PageSelectorTabController!;

    setState(() {
      if (!controller.indexIsChanging && controller.index!=controller.length ) {
        controller.animateTo(controller.index - 1);
      }
    });
  }


  Future<void> CloseFunction() async {
    ImpactPageSelectorLoaded = "Saved";
    await ImpactSaveAndGetAllInfo();
    Navigator.of(context).pushReplacement(MaterialPageRoute(builder:(context)=>this.widget.RedirectTo));
  }


  Widget ReturnNextButtonFunc(Ind){
    if(this.widget.NextWidget==null){
      return Container(
        key:Impact_PageSelector_Next_Guide,
        child:(this.widget.IsRTL==true)?ImpactPS1ButtonNextRTL(
          parent:this,
          RedirectTo:this.widget.RedirectTo,
        ):Impact_PageSelector2_Button_NextLTR(
          parent:this,
          RedirectTo:this.widget.RedirectTo,
        ),
      );
    }
    else {
      if(PageSelectorTabController!.index==Ind){
        return SizedBox();
      }
      else {
        return GestureDetector(
          onTap:(){
            setState(() {
              if(this.widget.IsRTL==true){
                NextRTLFunction();
              }
              else {
                NextLTRFunction();
              }
            });
          },
          child:this.widget.NextWidget,
        );
      }
    }
  }

  Widget ReturnNotNowButton(Ind){
    if(this.widget.NotNowWidget==null){
      return GestureDetector(
        onTap:(){
          Navigator.pushReplacement(context,MaterialPageRoute(builder:(context)=>this.widget.RedirectTo));
        },
        child:(PageSelectorTabController!.index==((this.widget.IsRTL==true)?0:this.widget.PagesContent!.length-1))?SizedBox():Container(
          key: Impact_PageSelector_NotNow_Guide,
          child:(this.widget.NotNowWidget==null)?Impact_PageSelector2_Button_NotNow(
            Redirecto:this.widget.RedirectTo,
            parent:this,
          ):this.widget.NotNowWidget,
        ),
      );
    }
    else {
      if(PageSelectorTabController!.index==Ind){
        return SizedBox();
      }
      else {
        return GestureDetector(
          onTap:(){
            CloseFunction();
          },
          child:this.widget.NotNowWidget,
        );
      }
    }
  }


  Widget ReturnCloseButton(Ind){
    if(this.widget.CloseWidget==null && PageSelectorTabController!.index==Ind){
      return Padding(
        padding: const EdgeInsets.only(left:35,right:35),
        child: ImpactButton2(
          Txt:(this.widget.CloseTxt==null)?ImpactLang["Close"].toString():this.widget.CloseTxt.toString(),
          Do:() async {
            CloseFunction();
          },
          W:MediaQuery.of(context).size.width-90,
          H:30.0,
        ),
      );
    }
    else {
      if(PageSelectorTabController!.index==Ind){
        return GestureDetector(
          onTap:(){
            CloseFunction();
          },
          child:this.widget.CloseWidget!,
        );
      }
      else {
        return SizedBox();
      }
    }



  }


  @override
  Widget build(BuildContext context) {
    return Scaffold(
      body: DefaultTabController(
        initialIndex:0,
        length:this.widget.PagesContent!.length,
        child: Builder(
            builder: (BuildContext context){

              return Stack(
                children: <Widget>[
                  Container(
                    width:MediaQuery.of(context).size.width,
                    height: MediaQuery.of(context).size.height,
                    child: TabBarView(
                      controller:PageSelectorTabController,
                      children: <Widget>[
                        for(int i=0;i<this.widget.PagesContent!.length;i++)
                          this.widget.PagesContent![i],
                      ],
                    ),
                  ),
                  Padding(
                    padding: EdgeInsets.only(
                        top:MediaQuery.of(context).size.height*0.7
                    ),
                    child: Container(
                        child:Center(
                          child:TabPageSelector(
                            controller:PageSelectorTabController,
                            color:this.widget.TabPageSelectorColor,
                            selectedColor:this.widget.ActiveTabPageSelectorColor,
                          ),
                        )
                    ),
                  ),

                  Container(
                      child:Column(children: <Widget>[
                        SizedBox(height:MediaQuery.of(context).size.height*0.9,),
                        Directionality(
                            textDirection:(this.widget.IsRTL==true)?TextDirection.rtl:TextDirection.ltr,
                            child:Stack(
                              children: [

                                Row(
                                  mainAxisAlignment:MainAxisAlignment.spaceBetween,
                                  children: <Widget>[

                                    ReturnNextButtonFunc(
                                        (this.widget.IsRTL==true)?0:PageSelectorTabController!.length-1
                                    ),

                                    ReturnNotNowButton(
                                        (this.widget.IsRTL==true)?0:PageSelectorTabController!.length-1
                                    ),


                                  ],
                                ),

                                ReturnCloseButton(
                                    (this.widget.IsRTL==true)?0:PageSelectorTabController!.length-1
                                ),
                              ],
                            )
                        )
                      ],)
                  ),


                ],
              );
            }
        ),
      ),
    );
  }

}