import 'package:flutter/material.dart';
import 'package:impact/0_Impact_Global/2_Shared_Preference.dart';
import '../Impact_Page_Selector_Guide.dart';
import '2_Widgets/PS3_LTR_Close_Button.dart';
import '2_Widgets/PS3_LTR_Next_Prev_Buttons.dart';
import '2_Widgets/PS3_RTL_Next_Prev_Buttons.dart';


class Impact_PageSelector_3 extends StatefulWidget{
  var RedirectTo;
  List<Impact_PageSelector_3_Item> PagesContent;
  LinearGradient? MainGrad;
  RadialGradient? RadialGrad;
  Color? ActiveTabPageSelectorColor;
  Color? TabPageSelectorColor,ButtonBgColor;
  String? NextTxt,PrevTxt,SkipTxt;
  TextStyle? TitleStyle,DescriptionStyle,BtnTxtStyle;
  bool? IsRTL,ShowTutorial;
  String? NextGuideTxt,NotNowTitle,NotNowGuideTxt,NotNowTxt,PrevGuideTxt,CloseTxt;
  Color? TargetBgColor,GuideBgColor;
  Alignment? SkipAlignment;

  Impact_PageSelector_3({
    this.RedirectTo,
    required  this.PagesContent,
    this.MainGrad,
    this.RadialGrad,
    this.ActiveTabPageSelectorColor,
    this.TabPageSelectorColor,
    this.ButtonBgColor,
    this.NextTxt,
    this.PrevTxt,
    this.SkipTxt,
    this.TitleStyle,
    this.DescriptionStyle,
    this.BtnTxtStyle,
    this.IsRTL,
    this.ShowTutorial,
    this.NextGuideTxt,
    this.NotNowTitle,
    this.NotNowGuideTxt,
    this.NotNowTxt,
    this.TargetBgColor,
    this.GuideBgColor,
    this.SkipAlignment,
    this.PrevGuideTxt,
  });

  Impact_PageSelector_3_State createState() => Impact_PageSelector_3_State();
}

class Impact_PageSelector_3_State extends State<Impact_PageSelector_3>  with SingleTickerProviderStateMixin {
  TabController? PageSelectorTabController;
  int ControllerIndex = 0;

  @override
  void initState(){
    super.initState();
    if(ImpactSelectedLang=="Arabic"){
      this.widget.IsRTL = true;
    }
    PageSelectorTabController = new TabController(
        length: this.widget.PagesContent.length,
        vsync: this,
        initialIndex:(this.widget.IsRTL==true)?this.widget.PagesContent.length-1:0
    );
    if(this.widget.IsRTL==true){
      ControllerIndex = this.widget.PagesContent.length-1;
    }
    else {
      ControllerIndex = 0;
    }
    PageSelectorTabController?.addListener(() {
      setState(() {
        ControllerIndex = PageSelectorTabController!.index;
      });
      print("~~~~~~Impact Active Page Index $ControllerIndex~~~~~~~~");
    });
    if(this.widget.IsRTL==true && this.widget.SkipAlignment==null){
      this.widget.SkipAlignment = Alignment.topRight;
    }
    if(this.widget.ShowTutorial==true){
      initImpactPageSelectorTargets(
          NextTitle      : this.widget.NextTxt,
          NextGuideTxt   : this.widget.NextGuideTxt,
          NotNowTitle    : this.widget.NotNowTxt,
          NotNowGuideTxt : this.widget.NotNowGuideTxt,
          TargetBgColor  : this.widget.TargetBgColor,
          CameFrom       : "PS3",
          PrevGuideTxt   : this.widget.PrevGuideTxt,
          PrevTitle      : this.widget.PrevTxt
      );
      showImpactPageSelectorTutorial(
          context,
          this.widget.GuideBgColor,
          this.widget.SkipTxt,
          this.widget.SkipAlignment,
          "PS3",
          this,
          this.widget.IsRTL
      );
    }
  }

  void NextLTRFunction(){
    print("Clicked!!!");
    var index = PageSelectorTabController!.index;
    TabController controller = PageSelectorTabController!;
    setState(() {
      if (!controller.indexIsChanging && controller.index!=controller.length ) {
        controller.animateTo(controller.index + 1);
      }
    });
  }

  void PrevLTRFunction(){
    print("Clicked!!!");
    var index = PageSelectorTabController!.index;
    TabController controller = PageSelectorTabController!;
    setState(() {
      if (!controller.indexIsChanging && controller.index!=controller.length ) {
        controller.animateTo(controller.index - 1);
      }
    });
  }

  void PrevRTLFunction(){
    print("Clicked!!!");
    var index = PageSelectorTabController!.index;
    TabController controller = PageSelectorTabController!;
    setState(() {
      if (!controller.indexIsChanging && controller.index!=controller.length ) {
        controller.animateTo(controller.index + 1);
      }
    });
  }

  void NextRTLFunction(){
    print("Clicked!!!");
    TabController controller = PageSelectorTabController!;

    setState(() {
      if (!controller.indexIsChanging && controller.index!=controller.length ) {
        controller.animateTo(controller.index - 1);
      }
    });
  }




  @override
  Widget build(BuildContext context) {
    return Scaffold(
        body:Container(
          width:MediaQuery.of(context).size.width,
          height:MediaQuery.of(context).size.height,
          decoration:BoxDecoration(
              gradient:(this.widget.MainGrad==null)?LinearGradient(
                  colors:[
                    Colors.blue,
                    Colors.blueGrey
                  ]
              ):this.widget.MainGrad
          ),
          child:DefaultTabController(
            length:this.widget.PagesContent.length,
            child: Builder(
              builder: (BuildContext context) => Stack(
                children: <Widget>[


                  Container(
                    width:MediaQuery.of(context).size.width,
                    height: MediaQuery.of(context).size.height,
                    child: TabBarView(
                      controller:PageSelectorTabController,
                      children: <Widget>[
                        for(int i=0 ; i<this.widget.PagesContent.length; i++)
                          Column(
                            children: <Widget>[
                              Container(
                                width:330,
                                height:330,
                                decoration: BoxDecoration(
                                  //Applying Radial Gradient
                                    gradient:this.widget.RadialGrad
                                ),
                                //Take Centered Image With Width And Height 90x90
                                child:Center(
                                  child:Image.asset(
                                    this.widget.PagesContent[i].image.toString(),
                                    height :(this.widget.PagesContent[i].ImgHeight==null)?200:this.widget.PagesContent[i].ImgHeight,
                                    width :(this.widget.PagesContent[i].ImgWidth==null)?200:this.widget.PagesContent[i].ImgWidth,
                                  ),
                                ),
                              ),
                              Text(
                                this.widget.PagesContent[i].title,
                                textDirection:TextDirection.ltr,
                                style:(this.widget.TitleStyle==null)?TextStyle(
                                  color:Colors.white,
                                  fontSize:20,
                                ):this.widget.TitleStyle,
                              ),
                              //Row3 Take Description Ar Or En Based On Language
                              Padding(
                                padding: const EdgeInsets.only(left:40,right:40,top:10),
                                child: Text(
                                  this.widget.PagesContent[i].description,
                                  textDirection:TextDirection.ltr,
                                  style:(this.widget.DescriptionStyle==null)?TextStyle(
                                    color:Colors.white,
                                    fontSize:16,
                                  ):this.widget.DescriptionStyle,
                                ),
                              ),
                            ],
                          ),
                      ],
                    ),
                  ),

                  Padding(
                    padding:EdgeInsets.only(top:MediaQuery.of(context).size.height*0.7),
                    child: Container(
                        child:Center(
                          child:TabPageSelector(
                            controller:PageSelectorTabController,
                            color:this.widget.TabPageSelectorColor,
                            selectedColor:this.widget.ActiveTabPageSelectorColor,
                          ),
                        )
                    ),
                  ),

                  Padding(
                    padding:EdgeInsets.only(top:MediaQuery.of(context).size.height*0.9),
                    child: Padding(
                      padding: const EdgeInsets.only(left:30,right:30),
                      child: (this.widget.IsRTL==true)?

                      (PageSelectorTabController!.index==0)?
                      PS3_LTR_Close_Button(parent:this,):
                      PS3_RTL_Next_Prev_Buttons(parent:this,)
                          :



                      (PageSelectorTabController!.index==this.widget.PagesContent.length-1)?
                        PS3_LTR_Close_Button(parent:this,):
                        PS3_LTR_Next_Prev_Buttons(parent:this,)

                    ),
                  ),



                  Container(
                    width:MediaQuery.of(context).size.width,
                    height:90,
                    child:Align(
                      alignment:(this.widget.IsRTL==true)?Alignment.centerLeft:Alignment.centerRight,
                      child:Padding(
                        padding: const EdgeInsets.all(8.0),
                        child: TextButton(
                          child:Text(
                            (this.widget.SkipTxt==null)?ImpactLang["Skip"]:this.widget.SkipTxt,
                            key:Impact_PageSelector_NotNow_Guide,
                            style:TextStyle(
                                color:Colors.white
                            ),
                          ),
                          onPressed:() async {
                            ImpactPageSelectorLoaded="Saved";
                            await ImpactSaveAndGetAllInfo();
                            Navigator.pushReplacement(context,MaterialPageRoute(builder:(context)=>this.widget.RedirectTo));
                          },
                        ),
                      ),
                    ),
                  ),

                ],
              ),
            ),
          ),
        )
    );
  }
}


class Impact_PageSelector_3_Item {
  var image,title,description;
  double? ImgWidth,ImgHeight;

  Impact_PageSelector_3_Item({
    required  this.image,
    required  this.title,
    required  this.description,
    this.ImgWidth,
    this.ImgHeight,
  });

}



