import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:impact/0_Impact_Global/2_Shared_Preference.dart';
import 'package:impact/8_Component/2_Wave_Clipper_1.dart';
import '../Impact_Page_Selector_Guide.dart';
import 'Widgets/PS4_Close_Button.dart';
import 'Widgets/PS4_LTR_Next_Prev_Buttons.dart';
import 'Widgets/PS4_RTL_Next_Prev_Buttons.dart';


class Impact_PageSelector_4 extends StatefulWidget{
  var RedirectTo;
  List<Impact_PageSelector_4_Item> PagesContent;
  Color? ActiveTabPageSelectorColor;
  Color? TabPageSelectorColor,TargetBgColor,GuideBgColor,BgColor,WaveColor,ButtonBgColor,SkipColor;
  bool? IsRTL,ShowTutorial;
  String? NextTxt,NextGuideTxt,NotNowTxt,NotNowGuideTxt,SkipTxt,PrevTxt,CloseTxt,PrevGuideTxt;
  Alignment? SkipAlignment;
  TextStyle? TitleStyle,DescriptionStyle,BtnTxtStyle,SkipTextStyle;

  Impact_PageSelector_4({
    this.RedirectTo,
    required this.PagesContent,
    required this.ActiveTabPageSelectorColor,
    required this.TabPageSelectorColor,
    this.IsRTL,
    this.ShowTutorial,
    this.TargetBgColor,
    this.NextTxt,
    this.NextGuideTxt,
    this.NotNowTxt,
    this.NotNowGuideTxt,
    this.GuideBgColor,
    this.SkipTxt,
    this.SkipAlignment,
    this.BgColor,
    this.WaveColor,
    this.ButtonBgColor,
    this.SkipColor,
    this.TitleStyle,
    this.DescriptionStyle,
    this.CloseTxt,
    this.BtnTxtStyle,
  });

  Impact_PageSelector_4_State createState() => Impact_PageSelector_4_State();
}

class Impact_PageSelector_4_State extends State<Impact_PageSelector_4> with SingleTickerProviderStateMixin {
  TabController? PageSelectorTabController;
  int SelectedIndexPage=0;
  var Wave=WaveClipperOne(flip:false,reverse: true);

  @override
  void initState(){
    super.initState();
    if(ImpactSelectedLang=="Arabic"){
      this.widget.IsRTL = true;
    }
    PageSelectorTabController = new TabController(
        length: this.widget.PagesContent.length,
        vsync: this,
        initialIndex:(this.widget.IsRTL==true)?this.widget.PagesContent.length-1:0
    );
    PageSelectorTabController?.addListener(() {
      setState(() {
        SelectedIndexPage = PageSelectorTabController!.index;
      });
    });
    if(this.widget.ShowTutorial==true){
      initImpactPageSelectorTargets(
          NextTitle      : this.widget.NextTxt,
          NextGuideTxt   : this.widget.NextGuideTxt,
          NotNowTitle    : this.widget.NotNowTxt,
          NotNowGuideTxt : this.widget.NotNowGuideTxt,
          TargetBgColor  : this.widget.TargetBgColor,
          CameFrom       : "PS4",
          PrevGuideTxt   : this.widget.PrevGuideTxt,
          PrevTitle      : this.widget.PrevTxt
      );
      showImpactPageSelectorTutorial(
          context,
          this.widget.GuideBgColor,
          this.widget.SkipTxt,
          this.widget.SkipAlignment,
          "PS4",
          this,
          this.widget.IsRTL
      );
    }
  }


  void NextLTRFunction(){
    print("Clicked!!!");
    var index = PageSelectorTabController!.index;
    TabController controller = PageSelectorTabController!;
    setState(() {
      if (!controller.indexIsChanging && controller.index!=controller.length ) {
        controller.animateTo(controller.index + 1);
      }
    });
  }

  void PrevLTRFunction(){
    print("Clicked!!!");
    var index = PageSelectorTabController!.index;
    TabController controller = PageSelectorTabController!;
    setState(() {
      if (!controller.indexIsChanging && controller.index!=controller.length ) {
        controller.animateTo(controller.index - 1);
      }
    });
  }

  void PrevRTLFunction(){
    print("Clicked!!!");
    var index = PageSelectorTabController!.index;
    TabController controller = PageSelectorTabController!;
    setState(() {
      if (!controller.indexIsChanging && controller.index!=controller.length ) {
        controller.animateTo(controller.index + 1);
      }
    });
  }

  void NextRTLFunction(){
    print("Clicked!!!");
    TabController controller = PageSelectorTabController!;

    setState(() {
      if (!controller.indexIsChanging && controller.index!=controller.length ) {
        controller.animateTo(controller.index - 1);
      }
    });
  }





  @override
  Widget build(BuildContext context) {
    return Scaffold(
        body:DefaultTabController(
          length:this.widget.PagesContent.length,
          child: Builder(
              builder: (BuildContext context ) => Stack(
                children: [

                  TabBarView(
                    controller:PageSelectorTabController,
                    children: [

                      for(int i=0;i<this.widget.PagesContent.length;i++)
                        Container(
                            width:MediaQuery.of(context).size.width,
                            height:MediaQuery.of(context).size.height,
                            color:(this.widget.BgColor==null)?ImpactPrimaryColor:this.widget.BgColor,
                            child:Padding(
                              padding: const EdgeInsets.only(
                                  bottom:208.0
                              ),
                              child: Column(
                                mainAxisAlignment:MainAxisAlignment.center,
                                crossAxisAlignment:CrossAxisAlignment.center,
                                children: [
                                  SizedBox(height:35,),
                                  Padding(
                                    padding: const EdgeInsets.only(left:18,right:18),
                                    child: Column(
                                      mainAxisAlignment:MainAxisAlignment.center,
                                      crossAxisAlignment:CrossAxisAlignment.center,
                                      children: [
                                        Text(
                                          this.widget.PagesContent[i].title,
                                          style:(this.widget.TitleStyle==null)?TextStyle(
                                            color:Colors.white,
                                            fontSize:17,
                                          ):this.widget.TitleStyle,
                                        ),
                                        SizedBox(height:10,),
                                        Padding(
                                          padding: const EdgeInsets.only(left:0),
                                          child: Text(
                                            this.widget.PagesContent[i].description,
                                            textAlign:TextAlign.center,
                                            style:(this.widget.DescriptionStyle==null)?TextStyle(
                                              color:Colors.white,
                                              fontSize:12,
                                            ):this.widget.DescriptionStyle,
                                          ),
                                        )
                                      ],
                                    ),
                                  ),
                                  Image.asset(
                                    this.widget.PagesContent[i].image,
                                    width:(this.widget.PagesContent[i].ImgWidth==null)?200:this.widget.PagesContent[i].ImgWidth,
                                    height:(this.widget.PagesContent[i].ImgHeight==null)?200:this.widget.PagesContent[i].ImgHeight,
                                  ),

                                ],
                              ),
                            )
                        ),


                    ],
                  ),
                  Container(
                      width:MediaQuery.of(context).size.width,
                      height:MediaQuery.of(context).size.height,
                      child:Column(
                        children: [
                          SizedBox(height:MediaQuery.of(context).size.height*0.65),
                          Container(
                            height:MediaQuery.of(context).size.height*0.35,
                            child:Column(
                              children: [
                                ClipPath(
                                    clipper:Wave,
                                    child:Container(
                                      width:MediaQuery.of(context).size.width,
                                      height:MediaQuery.of(context).size.height*0.35,
                                      color:(this.widget.WaveColor==null)?Colors.white:this.widget.WaveColor,
                                      child:Column(
                                        children: [
                                          SizedBox(height:MediaQuery.of(context).size.height*0.1,),


                                          (this.widget.IsRTL==true)?

                                          (PageSelectorTabController!.index==0)?
                                           PS4_Close_Button(parent:this,):
                                           PS4_RTL_Next_Prev_Buttons(parent:this,) :



                                          (PageSelectorTabController!.index==this.widget.PagesContent.length-1)?
                                          PS4_Close_Button(parent:this,):
                                          PS4_LTR_Next_Prev_Buttons(parent:this,),



                                          SizedBox(height:MediaQuery.of(context).size.height*0.05,),

                                          TabPageSelector(
                                            selectedColor:this.widget.ActiveTabPageSelectorColor,
                                            color:this.widget.TabPageSelectorColor,
                                            controller:PageSelectorTabController,
                                          ),

                                          Expanded(
                                            child: Align(
                                            alignment:Alignment.bottomRight,
                                            child:TextButton(
                                              child:Text(
                                                (this.widget.SkipTxt==null)?ImpactLang["Skip"]:this.widget.SkipTxt,
                                                key:Impact_PageSelector_NotNow_Guide,
                                                style:(this.widget.SkipTextStyle==null)?TextStyle(
                                                    color: ImpactPrimaryColor,
                                                    fontSize: 20,
                                                    fontWeight: FontWeight.bold
                                                ):this.widget.SkipTextStyle,
                                              ),
                                              onPressed:() async {
                                                if(this.widget.RedirectTo==null){
                                                  print('~~~~~~Impact Not RedirectTo Passed!~~~~~~');
                                                }
                                                else {
                                                  Navigator.push(context,MaterialPageRoute(builder:(context)=>this.widget.RedirectTo));
                                                }
                                              },
                                            ),
                                          ),
                                          ),
                                        ],
                                      ),
                                    )
                                ),

                              ],
                            ),
                          )
                        ],
                      )
                  ),



                ],
              )



          ),
        )

    );

  }

}


class Impact_PageSelector_4_Item {
  var image,title,description;
  double? ImgWidth,ImgHeight;

  Impact_PageSelector_4_Item({
    required  this.image,
    required  this.title,
    required  this.description,
    this.ImgWidth,
    this.ImgHeight,
  });

}



