import 'package:flutter/material.dart';
import 'package:impact/0_Impact_Global/2_Shared_Preference.dart';
import 'package:impact/0_Impact_Global/8_Impact_Global.dart';
import 'package:impact/8_Component/4_Tutorial_Guide.dart';
import 'package:impact/8_Component/5_Guide_Content.dart';

List<TargetFocus> targets = <TargetFocus>[];

GlobalKey Impact_PageSelector_Next_Guide   = GlobalKey();
GlobalKey Impact_PageSelector_NotNow_Guide = GlobalKey();
GlobalKey Impact_PageSelector_Prev_Guide   = GlobalKey();

void initImpactPageSelectorTargets({
  required String? NextTitle,
  required String? NextGuideTxt,
  required String? NotNowTitle,
  required String? NotNowGuideTxt,
  required Color? TargetBgColor,
  required String? CameFrom,
  required String? PrevTitle,
  required String? PrevGuideTxt,
}) {
  targets.add(
    TargetFocus(
      identify: "Impact_PageSelector_NotNow_Guide",
      keyTarget: Impact_PageSelector_NotNow_Guide,
      contents: [
        TargetContent(
          align:(CameFrom=='PS3')?ContentAlign.bottom:ContentAlign.top,
          builder: (context, controller) {
            return ImpactGuideContent(
              title:(NextTitle==null)?ImpactLang["NotNow"]:NextTitle,
              description:(NextGuideTxt==null)?ImpactLang["PSGuide2"]:NextGuideTxt,
              BackgroundColor :TargetBgColor
            );
          },
        ),
      ],
    ),
  );
  targets.add(
    TargetFocus(
      identify: "Impact_PageSelector_Next_Guide",
      keyTarget: Impact_PageSelector_Next_Guide,
      contents: [
        TargetContent(
          align: ContentAlign.top,
          builder: (context, controller) {
            return ImpactGuideContent(
                title:(NextTitle==null)?ImpactLang["Next"]:NextTitle,
                description:(NextGuideTxt==null)?ImpactLang["PSGuide1"]:NextGuideTxt,
                BackgroundColor :TargetBgColor
            );
          },
        ),
      ],
    ),
  );
  targets.add(
    TargetFocus(
      identify: "Impact_PageSelector_Prev_Guide",
      keyTarget: Impact_PageSelector_Prev_Guide,
      contents: [
        TargetContent(
          align:ContentAlign.top,
          builder: (context, controller) {
            return ImpactGuideContent(
                title:(PrevTitle==null)?ImpactLang["Prev"]:PrevTitle,
                description:(PrevGuideTxt==null)?ImpactLang["PSGuide3"].toString():PrevGuideTxt,
                BackgroundColor :TargetBgColor
            );
          },
        ),
      ],
    ),
  );



}

void showImpactPageSelectorTutorial(context,GuideBgColor,SkipTxt,SkipAlignment,CameFrom,parent,IsRTL) {
  ImpactGlobalTutorialGuide = TutorialCoachMark(
    context,
    alignSkip:(SkipAlignment==null)?Alignment.topLeft:SkipAlignment,
    targets: targets,
    colorShadow:(GuideBgColor==null)?Colors.blueGrey:GuideBgColor,
    textSkip:(SkipTxt==null)?ImpactLang["Skip"]:SkipTxt,
    paddingFocus: 10,
    opacityShadow: 0.8,
    onFinish: () {
      print("finish");
    },
    onClickTarget: (target) {
      print('onClickTarget: $target');

      if(CameFrom=="PS3"){
        if(target.identify=="Impact_PageSelector_NotNow_Guide"){
          parent.setState((){
            if(IsRTL==null || IsRTL==false){
              parent.NextLTRFunction();
            }
            else {
              parent.NextRTLFunction();
            }
          });
        }
      }

      else if(CameFrom=="PS4"){
        print("Entered in PS4");
        if(target.identify=="Impact_PageSelector_Next_Guide"){
          parent.setState((){
            if(IsRTL==null || IsRTL==false){
              parent.NextLTRFunction();
            }
            else {
              parent.NextRTLFunction();
            }
          });
        }
      }


    },
    onSkip: () {
      print("skip");
    },
    onClickOverlay: (target) {
      print('onClickOverlay: $target');
    },
  )..show();
}